#include <iostream>

using namespace std;

int main()
{
    int N, M, K;
    cin >> N >> M >> K;
    long long s[N];
    int a[N][M];

    for(int i = 0; i < N; i++){
        int x;
        cin >> x;
        s[i] = x;
    }

    for(int i = 0; i < N; i++){
        for (int y = 0; y < M; y++){
            int x;
            cin >> x;
            a[i][y] = x;
        }
    }

    long long sol[K+1][N];
    for(int i = 0; i < N; i++) sol[0][i] = 0;

    for(int i = 1; i <= K; i++){
        for(int y = 0; y < N; y++) sol[i][y] = 0;
        for(int y = 0; y < N; y++)
            for(int z = 0; z < M; z++)
                if(i > a[y][z]) sol[i][y] += s[y];
    }

    long long res[K+1] = {};
    int prev[K+1][N];
    int prevCost[K+1] = {};

    for(int i = 0; i < N; i++) prev[0][i] = 0;

    for(int i = 1; i <= K; i++){
        int currIndex = 0;
        for(int y = 0; y < N; y++){
            if(res[i] < sol[i][y]){
                res[i] = sol[i][y];
                currIndex = y;
            }
        }
        int curr[N] = {};
        int currCost = i;
        while(sol[currCost][currIndex] == sol[currCost-1][currIndex] && currCost > 0) currCost--;
        curr[currIndex] = currCost;

        while(i - currCost > 0){
            int currMax = 0;
            currIndex = 0;
            for(int y = 0; y < N; y++){
                if(!curr[y] && currMax < sol[i - currCost][y]){
                    currMax = sol[i - currCost][y];
                    currIndex = y;
                }
            }

            if(currMax == 0) break;
            int curCost = i - currCost;
            while(sol[curCost][currIndex] == sol[curCost-1][currIndex] && curCost > 0) curCost--;
            curr[currIndex] = sol[curCost][currIndex];
            currCost += curCost;
            res[i] += sol[curCost][currIndex];
        }

        if(res[i] > res[i-1]){
            prevCost[i] = currCost;
            for(int y = 0; y < N; y++) prev[i][y] = curr[y];
        }
        else {
            res[i] = res[i-1];
            prevCost[i] = prevCost[i-1];
            for(int y = 0; y < N; y++) prev[i][y] = prev[i-1][y];
        }
    }

    cout << res[K];
}