#include <bits/stdc++.h>
using namespace std;

const int N = 2e5 + 7;
int fwt[N][2];

void ins(int x, int w) {
    for (; x < N; x += x & -x) {
        fwt[x][w]++;
    }
}
int ask(int x, int w) {
    int r = 0;
    for (; x; x -= x & -x) {
        r += fwt[x][w];
    }
    return r;
}

int mid(int w, int k) {
    int l = 1, r = N;
    while (l <= r) {
        int m = (l + r) >> 1;
        int a = ask(m - 1, w);
        int b = ask(m, w);
        if (k - b == a) {
            return m;
        }
        if (k - b > a) {
            l = m + 1; continue;
        }
        r = m - 1;
    }
    return 0;
}

void f(vector<int> &x) {
    int n = x.size();
    vector<int> y = x;
    sort(y.begin(), y.end());
    map<int,int> m;
    for (int i = 0; i < n; i++) {
        m[y[i]] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        x[i] = m[x[i]];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n; cin >> n;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    f(x); f(y);
    map<pair<int,int>, int> m;
    for (int i = 0; i < n; i++) {
        m[{x[i], y[i]}] = i + 1;
        ins(x[i], 0); ins(y[i], 1);
        int a = mid(0, i + 1);
        int b = mid(1, i + 1);
        if (!m[{a, b}]) {
            cout << -1 << endl;
            continue;
        }
        cout << m[{a, b}] << endl;
    }
}