#include <bits/stdc++.h>
#define FAST {ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);}
#define ll long long
#define ull unsigned long long
#define pb push_back
#define fi first
#define se second
#define ld long double
#define pii pair<int,int>
#define pll pair<long long,long long>
#define all(a) (a).begin(), (a).end()
#define mp make_pair
using namespace std;

const double eps = 0.00000001;
const int NMAX = 200020;
const ll modi = 1e9+7;
const ll inf = 1e10;

pii seg1[NMAX*4];
pii seg2[NMAX*4];
vector<pii>ulaz(NMAX);

void dodaj(pii * seg, int l, int r, int node, int pos, int sta ) {
    if ( l == r ) {
        seg[node].se = sta;
        seg[node].fi = 1;
        return;
    }
    int mid = (l+r)/2;
    if ( pos <= mid ) {
        dodaj(seg,l,mid,node*2+1,pos,sta);
    }
    else {
        dodaj(seg,mid+1,r,node*2+2,pos,sta);
    }

    seg[node].fi = seg[node*2+1].fi + seg[node*2+2].fi;
    seg[node].se = seg[node*2+2].se;
}

int nadji(pii * seg, int l, int r, int node, int koliko) {
    if ( l == r ) {
        return seg[node].se;
    }

    if ( seg[node].fi < koliko ) return -1;
    int mid = (l+r)/2;
    if ( seg[node*2+1].fi >= koliko ) {
        return nadji(seg,l,mid,node*2+1,koliko);
    }
    else {
        return nadji(seg,mid+1,r,node*2+2,koliko-seg[node*2+1].fi);
    }
}


int main () {
    FAST
    int n;
    cin >> n;
    vector<vector<int> >v(n);
    for (int i = 0 ; i < n ; i++ ) {
        int x,y;
        cin >> x >> y;
        ulaz[i].fi = x;
        ulaz[i].se = y;
        vector<int>temp = {x,y,i};
        v[i] = temp;
    }

    sort(all(v));

    for (int i = 0 ; i < n ; i++ ) {
        ulaz[v[i][2]].fi = i;
        swap(v[i][0], v[i][1]);
    }


    sort(all(v));

    for (int i = 0 ; i < n ; i++ ) {
        ulaz[v[i][2]].se = i;
        swap(v[i][0], v[i][1]);
    }

    for (int i = 0 ; i < n ; i++ ) {
        dodaj(seg1,0,n-1,0,ulaz[i].fi,i+1);
        dodaj(seg2,0,n-1,0,ulaz[i].se,i+1);

        if ( i%2 ) {
            cout << -1 << endl;
            continue;
        }

        int t1 = nadji(seg1,0,n-1,0,i/2+1);
        int t2 = nadji(seg2,0,n-1,0,i/2+1);
        //cout << t1 << ' ' << t2 <<  ' ';
        if ( t1 == t2 ) {
            cout << t1 << endl;
            continue;
        }
        cout << -1 << endl ;
    }
}