#include <iostream>

unsigned short cifre[19];
unsigned short ssume[19];

void ispis_debug(unsigned broj_cifra){
    for (unsigned i = 0; i < broj_cifra; i++) std::cout << cifre[i] << " ";
    std::cout << "\n";
    for (unsigned i = 0; i < broj_cifra; i++) std::cout << ssume[i] << " ";
    std::cout << "\n";
}

int main(){
    std::ios_base::sync_with_stdio(false);

    unsigned X, Y, A, B;
    std::cin >> X >> Y >> A >> B;

    //unsigned X;
    //std::cin >> X;

    unsigned broj_cifra = 0;
    {
        unsigned temp = X;
        while (temp > 0){
            cifre[broj_cifra++] = temp % 10;
            temp /= 10;
        }
    }

    ssume[broj_cifra - 1] = cifre[broj_cifra - 1];
    for (int i = broj_cifra - 2; i >= 0; i--) ssume[i] = ssume[i + 1] + cifre[i];

    bool found = false;
    for (unsigned n = X; n <= Y; n++){
        /*
        std::cout << n << "\n";
        ispis_debug(broj_cifra);
        std::cout << "---\n";
        //*/
        if (n == A * ssume[0] + B){
            std::cout << n << "\n";
            found = true;
            //ispis_debug(broj_cifra);
            break;
        }

        int cifra = 0;
        while (cifre[cifra] >= 9){
            cifre[cifra++] = 0;
        }
        cifre[cifra]++;
        ssume[cifra]++;
        unsigned temp_suma = ssume[cifra--];

        while (cifra >= 0){
            ssume[cifra--] = temp_suma;
        }
    }

    if (!found){
        std::cout << "-1\n";
    }

    return 0;
}