#include <iostream>
#include <algorithm>

unsigned s[200];
unsigned a[200][200];
unsigned long long dp[1001][201];

int main(){
    std::ios_base::sync_with_stdio(false);

    unsigned N, M, K;
    std::cin >> N >> M >> K;
    for (unsigned i = 0; i < N; i++) std::cin >> s[i];
    for (unsigned red = 0; red < N; red++)
        for (unsigned col = 0; col < M; col++) std::cin >> a[red][col];

    /*
    std::cout << "N: " << N << " M: " << M << " K: " << K << "\n";
    for (unsigned i = 0; i < N; i++) std::cout << s[i] << " ";
    std::cout << "\n";
    for (unsigned red = 0; red < N; red++){
        for (unsigned col = 0; col < M; col++) {
            std::cout << a[red][col] << " ";
        }
        std::cout << "\n";
    }
    //*/
    if (N == 1){
        unsigned long long r = 0;
        for (unsigned i = 0; i < M; i++) if (a[0][i] < K) r += s[0];
        std::cout << r << "\n";
        return 0;
    }

    if (M == 1){
        for (unsigned row = 0; row < K; row++) dp[row][0] = 0;
        for (unsigned col = 0; col < N; col++) dp[0][col] = 0;
        for (unsigned row = 1; row <= K; row++){
            for (unsigned col = 1; col <= N; col++){
                unsigned long long if_we_take = 0;
                if (row > a[col - 1][0]) if_we_take = dp[row - (a[col - 1][0] + 1)][col - 1] + s[col - 1];
                unsigned long long if_we_dont = dp[row][col - 1];
                dp[row][col] = std::max(if_we_take, if_we_dont);
            }
        }
        /*
        for (int row = 0; row <= K; row++){
            for (int col = 0; col <= N; col++){
                std::cout << dp[row][col] << " ";
            }
            std::cout << "\n";
        }
        std::cout << "\n";
        //*/
        std::cout << dp[K][N] << "\n";
        return 0;
    }

    std::cout << " =(\n";

    return 0;
}
/*
3 1 4
5 3 4
2
1
3

2 1 6
10 12
2
3
*/