#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define fi first
#define se second
#define en '\n'
#define sp ' '
#define tb '\t'
#define ri(n) int n; cin >> n
#define rl(n) ll n; cin >> n
#define rs(s) string s; cin >> s
#define rc(c) char c; cin >> c
#define rv(v) for (auto &x : v) cin >> x
#define pven(v) for (auto x : v) cout << x << en
#define pv(v) for (auto x : v) cout << x << sp; cout << en
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define yes cout << "YES" << en
#define no cout << "NO" << en
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
#define ssort(a, b) if (a < b) swap(a, b)
#define bitcnt(a) __builtin_popcountll(a)
#define bithigh(a) 63-__builtin_clzll(a)
#define lg bithigh
ll highpow(ll a) { return 1LL << (ll)lg(a); }

using namespace std;

class BIT{
private:
    vector<ll> tree;
    int n;

    ll query(int pos){
        if (pos > n) pos = n;
        ll sum = 0;
        while (pos > 0){
            sum += tree[pos];
            pos -= pos & (-pos);
        }
        return sum;
    }
public:
    BIT(int s){
        tree = vector<ll>(s + 1, 0);
        n = s;
    }

    ll query(int l, int r){
        l++; r++;
        if (l > r) return 0;
        return query(r) - query(l-1);
    }

    void update(int pos, ll x){
        pos++;
        if (pos <= 0) return;
        while (pos <= n){
            tree[pos] += x;
            pos += pos & (-pos);
        }
    }
    void Print(){
        for (int i = 0; i < n; i++)
            cout << query(i, i) << sp;
        cout << en;
    }
};

const ll LINF = 4e18;
const int mxN = 2e5+10, INF = 2e9;
ll n, m, ax[mxN], ay[mxN];
array<int, 2> q[mxN];
map<int, int> mp[2];
map<array<int, 2>, int> in;
BIT* fen[2];

int BS(int x, int f){

    int l = 0, r = n-1, ans = n-1;
    while (l<=r){
        int k = (l + r + 1) / 2;
        if (fen[f]->query(0, k) >= x){
            ans = k;
            r = k - 1;
        }
        else l = k + 1;
    }
    return ans;
}

void Solve(){

    cin >> n;
    for (int i = 0; i < n; i++){
        ri(x); ri(y);
        ax[i] = x;
        ay[i] = y;
        q[i] = {x, y};
    }
    sort(ax, ax+n);
    sort(ay, ay+n);
    for (int i = 0; i < n; i++){
        mp[0][ax[i]] = i;
        mp[1][ay[i]] = i;
    }
    for (int i = 0; i < n; i++){
        int x = q[i][0], y = q[i][1];
        x = mp[0][x]; y = mp[1][y];
        in[{x, y}] = i+1;
    }
    fen[0] = new BIT(n);
    fen[1] = new BIT(n);
    for (int i = 0; i < n; i++){
        int x = q[i][0], y = q[i][1];
        x = mp[0][x]; y = mp[1][y];
        fen[0]->update(x, 1);
        fen[1]->update(y, 1);
        if (i&1){
            cout << -1 << en;
            continue;
        }
        x = BS(i/2+1, 0);
        y = BS(i/2+1, 1);
        if (in[{x, y}]) cout << in[{x, y}] << en;
        else cout << -1 << en;
    }
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);
    cout << setprecision(12) << fixed;
    cerr << setprecision(12) << fixed;
    cerr << "Started!" << endl;

    int t = 1;
    //cin >> t;
    while (t--)
        Solve();

    return 0;
}