#include <iostream>
#include <cmath>
#define ll long long

using namespace std;

bool check_num(ll num, ll& a, ll& b)
{
    ll sum = 0;
    ll pom = num;
    while(pom) sum += pom % 10, pom /= 10;
    return sum*a == num-b;
}

void solve()
{
    ll x,y,a,b;
    cin >> x >> y >> a >> b;
    if ( y < b ){
        cout << -1 << endl;
        return;
    }
    x = max(x - b, (ll)0);
    y -= b;
    if ( a == 0){
        cout << b << endl;
        return;
    }
    if( x % a != 0) x += a - x%a;
    for(ll i = x; i <= y; i += a){
        if(check_num(i+b, a, b)){
            cout << i+b << endl;
            return;
        }
    }
    cout << -1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}