#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long

using namespace std;

ll sum = 0;
ll maxsum = 0;

void brute(vector<vector<ll>>& a, vector<ll>& s, ll& n, ll& m, int k, int dep)
{
    if(k == 0 || dep == n)
    {
        maxsum = max(sum, maxsum);
        return;
    }
    for(int i=0;i<=k;i++){
        int upnd = upper_bound(a[dep].begin(), a[dep].end(), i) - a[dep].begin();
        if(i == a[dep][upnd]) upnd++;
        sum += s[dep] * upnd;
        brute(a,s,n,m,k-i,dep+1);
        sum -= s[dep] * upnd;
    }
}

void solve()
{
    ll n, m, k; cin >> n >> m >> k;
    vector<ll> s(n); for(auto& i : s) cin >> i;
    vector<vector<ll>> a(n, vector<ll>(m));
    for(auto& i : a){
        for(auto& j : i) cin >> j;
        sort(i.begin(), i.end());
    }
    if(n == 1) {
        int br = 0;
        for(int i=0; i < m; i++) br += k > a[0][i];
        cout << s[0] * br << endl;
        return;
    }
    if(n <= 6 && k <= 6)
    {
        brute(a, s, n, m, k, 0);
        cout << maxsum << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}