#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7;

inline int add(int a, int b) {
    a += b;
    if(a >= MOD) a -= MOD;
    return a;
}

inline int sub(int a, int b) {
    a -= b;
    if(a < 0) a += MOD;
    a %= MOD;
    return a;
}

const int mxN = 2004;

int levo[mxN][mxN];
int desno[mxN][mxN];
int dp[mxN][mxN];

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, k;
    cin >> n >> m >> k;
    vector<string> mat(n);
    for(auto &z : mat) cin >> z;

    //napravis funkciju ako skreces samo levo
    //desno racunas tako sto obrnes niz

    auto skreniDesno = [&](string s) {
        int desno = m-1;
        while(desno >= 0 && s[desno] == '1') --desno;
        int prvi = 0;
        while(prvi < m && s[prvi] == '1') ++prvi;

        vector<int> ans(m);

        map<int, int> moze;
        int bele = 0, crne = 0;
        for(int i = desno; i >= prvi; --i) {
            if(s[i] == '1') {
                ++crne;
            } else {
                if(i+1 < m && s[i+1] == '1') {
                    moze[crne] = bele;
                }
                ++bele;
            }
        }

//        for(auto z : moze) {
//            cerr << z.first << " : " << z.second << endl;
//        }
//        cerr << "--------" << endl;

        int oduzeli = 0;
        int oduzmiBele = 0;

        for(int i = prvi; i <= desno; ) {
            if(s[i] == '1') {
                int j = i;
                while(j <= desno && s[j] == '1') {
                    ++j;
                }
                oduzeli += (j-i);
                if(!moze.empty()) {
                    moze.erase(moze.begin());
                }
                i = j;
                continue;
            }

            int j = i;

//            cerr << i << " " << oduzeli << endl;
//            for(auto z : moze) {
//                cerr << z.first << " -> " << z.second << endl;
//            }
//            cerr << "-------" << endl;

            while(j <= desno && s[j] == '0') ++j;
            --j;
            auto it = moze.upper_bound(k+oduzeli);
            int vrednost = 0;
            if(it != moze.begin()) {
                //cerr << "usao " << i << endl;
                --it;
                //cerr << i << " = (" << it->first << ", " << it->second << ")" << endl;
                int asdf = it->second;
                asdf -= oduzmiBele;
                asdf -= (j-i);
                vrednost = max(vrednost, asdf);
            }
            int alo = 0;
            for(int u = j; u >= i; --u) {
                ans[u] = vrednost + alo;
                ++alo;
            }
            oduzmiBele += (j+1-i);
            i = j+1;
            //cerr << i << endl;
            //cerr << "Oduzeli bele: " << oduzmiBele << endl;
        }

        return ans;
    };

    //auto odg = skreniDesno(mat[0]);
    //for(auto z : odg) cout << z << " ";
    //return 0;

    for(int i = 0; i < n; ++i) {
        auto odg = skreniDesno(mat[i]);
        for(int j = 0; j < m; ++j) {
            desno[i][j] = odg[j];
        }
        string obrnuto = mat[i];
        reverse(obrnuto.begin(), obrnuto.end());
        odg = skreniDesno(obrnuto);
        reverse(odg.begin(), odg.end());
        for(int j = 0; j < m; ++j) {
            levo[i][j] = odg[j];
        }
    }

    /*
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            cerr << desno[i][j] << " ";
        }
        cerr << endl;
    }
    */

    for(int i = 0; i < m; ++i) {
        if(mat[n-1][i] == '0') {
            dp[n-1][i] = 1;
        }
    }

    for(int iter = n-1; iter >= 0; --iter) {
        vector<int> pref(m+1);
        /*
        for(int i = 0; i < m; ++i) {
            cerr << dp[iter][i] << " ";
        }
        cerr << endl;
        */
        for(int i = 0; i < m; ++i) {
            if(mat[iter][i] == '1') continue;
            int l = i+1;
            int r = i+desno[iter][i]+1;
            if(r < l) continue;
            pref[l] = add(pref[l], dp[iter][i]);
            pref[r] = sub(pref[r], dp[iter][i]);
        }

        for(int i = 0; i < m; ++i) {
            if(mat[iter][i] == '1') continue;
            int r = i;
            int l = i-levo[iter][i];
            if(r < l) continue;
            assert(l >= 0);
            pref[l] = add(pref[l], dp[iter][i]);
            pref[r] = sub(pref[r], dp[iter][i]);
        }

        for(int i = 1; i <= m; ++i) {
            pref[i] = add(pref[i], pref[i-1]);
        }

        /*
        for(int i = 0; i < m; ++i) {
            cerr << pref[i] << " ";
        }
        */

        for(int i = 0; i < m; ++i) {
            int dodaj = 0;
            dodaj = add(dodaj, pref[i]);
            dp[iter][i] = add(dp[iter][i], dodaj);
        }

        if(iter-1 >= 0) {
            for(int i = 0; i < m; ++i) {
                if(mat[iter-1][i] == '0') {
                    dp[iter-1][i] = add(dp[iter-1][i], dp[iter][i]);
                }
            }
        }
    }

    /*
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            cerr << dp[i][j] << " ";
        }
        cerr << endl;
    }
    */

    int ans = 0;
    for(int i = 0; i < m; ++i) {
        ans = add(ans, dp[0][i]);
    }

    cout << ans << '\n';
}

/*
1 9 3
010001100
*/