#include <bits/stdc++.h>

using namespace std;
//using namespace __gnu_pbds;

const int mxN = 2e5 + 12;
int st[4*mxN];

int n;

void update(int l1, int x, int i = 1, int l2 = 0, int r2 = n-1) {
    if(l2 == r2) {
        st[i] = x;
        return;
    }
    int m2 = (l2 + r2) / 2;
    if(l1 <= m2) update(l1, x, 2*i, l2, m2);
    else update(l1, x, 2*i+1, m2+1, r2);
    st[i] = st[2*i] + st[2*i+1];
}

int findKth(int x, int i = 1, int l2 = 0, int r2 = n-1) {
    if(l2 == r2) {
        return l2;
    }

    int m2 = (l2 + r2) / 2;
    if(st[2*i] >= x) {
        return findKth(x, 2*i, l2, m2);
    } else {
        return findKth(x-st[2*i], 2*i+1, m2+1, r2);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    vector<pair<int, int>> v(n);
    for(auto &z : v) cin >> z.first >> z.second;

    if(n <= 500) {
        for(int iter = 0; iter < n; ++iter) {
            int taj = -1;
            for(int i = 0; i <= iter; ++i) {
                int levoGore = 0, levoDole = 0;
                int desnoGore = 0, desnoDole = 0;
                for(int j = 0; j <= iter; ++j) {
                    if(i == j) continue;
                    if(v[j].second < v[i].second) {
                        if(v[j].first > v[i].first) {
                            ++levoDole;
                        } else {
                            ++levoGore;
                        }
                    } else {
                        if(v[j].first > v[i].first) {
                            ++desnoDole;
                        } else {
                            ++desnoGore;
                        }
                    }
                }

                if(levoGore == desnoDole && levoDole == desnoGore) {
                    taj = i+1;
                    break;
                }
            }

            cout << taj << '\n';
        }
        return 0;
    }

    map<int, int> compress;

    for(int i = 0; i < n; ++i) {
        compress[v[i].first] = i;
    }

    vector<int> gas;
    for(auto z : v) {
        gas.push_back(z.first);
    }
    sort(gas.begin(), gas.end());

    for(int iter = 0; iter < n; ++iter) {
        auto it = lower_bound(gas.begin(), gas.end(), v[iter].first);
        int gde = it - gas.begin();
        update(gde, 1);
        if(iter % 2 == 0) {
            int mu = findKth(iter/2);
            mu = gas[mu];
            cout << compress[mu]+1 << '\n';
        } else {
            cout << -1 << '\n';
        }
    }
}