#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 2005;
const int mod = 1000000007;

int n,m,k,a[N][N];
int dp[N][N],f[N][N];
int pf[N][N];
int sfmin[N][N],koji[N][N];

bool mozedesno(int v,int i,int j){
    assert(i < j);
    assert(a[v][i] == 0);

    int izm = pf[v][j]-pf[v][i-1];
    if(izm == 0) return 1;
    if(j == m) return 0;

    int l = j+1,r = m,ans = 0;
    while(l <= r){
        int mid = l+(r-l)/2;
        if(pf[v][mid]-mid <= pf[v][i-1]-j){
            ans = mid;
            r = mid-1;
        }
        else{
            l = mid+1;
        }
    }
    if(ans == 0) return 0;
    int gura = pf[v][ans]-pf[v][i-1];
    return gura <= k;

    /*for(int h = j+1; h <= m; h++){
        if(pf[v][h]-h <= pf[v][i-1]-j){
            int gura = pf[v][h]-pf[v][i-1];
            return gura <= k;
        }
    }
    return 0;*/
}

bool mozelevo(int v,int i,int j){
    assert(i > j);
    assert(a[v][i] == 0);

    int izm = pf[v][i]-pf[v][j-1];
    if(izm == 0) return 1;
    if(j == 1) return 0;

    int l = 1,r = j-1,ans = 0;
    while(l <= r){
        int mid = l+(r-l)/2;
        if(pf[v][mid-1]-mid >= pf[v][i]-j){
            ans = mid;
            l = mid+1;
        }
        else{
            r = mid-1;
        }
    }
    if(ans == 0) return 0;
    int gura = pf[v][i]-pf[v][ans-1];
    return gura <= k;

    /*for(int h = j-1; h >= 1; h--){
        if(pf[v][h-1]-h >= pf[v][i]-j){
            int gura = pf[v][i]-pf[v][h-1];
            return gura <= k;
        }
    }
    return 0;*/
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> k;
    for(int i = 1; i <= n; i++){
        string s;
        cin >> s;
        for(int j = 1; j <= m; j++){
            a[i][j] = s[j-1]-'0';
        }
    }

    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            pf[i][j] = pf[i][j-1]+a[i][j];
        }
    }
    for(int i = 1; i <= n; i++){
        for(int j = m; j >= 1; j--){
            int vr = pf[i][j]-j;
            if(j == m){
                sfmin[i][j] = vr;
                koji[i][j] = j;
            }
            else{
                sfmin[i][j] = min(sfmin[i][j+1],vr);
                if(vr <= sfmin[i][j+1]){
                    sfmin[i][j] = vr;
                    koji[i][j] = j;
                }
                else{
                    sfmin[i][j] = sfmin[i][j+1];
                    koji[i][j] = koji[i][j+1];
                }
            }
        }
    }

    //cout << mozedesno(3,1,2) << endl;

    for(int j = 1; j <= m; j++) dp[n+1][j] = 1;
    for(int v = n; v >= 1; v--){
        for(int i = 1; i <= m; i++){
            if(a[v][i] == 1) continue;

            /*int l = 1,r = i-1,anslevo = i;
            while(l <= r){
                int mid = l+(r-l)/2;
                if(mozelevo(i,j,mid)){
                    anslevo = mid;
                    r = mid-1;
                }
                else{
                    l = mid+1;
                }
            }*/

            int l = 1,r = i-1,ans1 = i;
            while(l <= r){
                int mid = l+(r-l)/2;
                if(pf[v][i]-pf[v][mid-1] <= k){
                    ans1 = mid;
                    r = mid-1;
                }
                else{
                    l = mid+1;
                }
            }
            int stalevo = max(1,pf[v][i]+ans1-pf[v][ans1-1]);
            int anslevo = min(i,stalevo);


            /*l = i+1,r = m;
            int ansdesno = i;
            while(l <= r){
                int mid = l+(r-l)/2;
                if(mozedesno(i,j,mid)){
                    ansdesno = mid;
                    l = mid+1;
                }
                else{
                    r = mid-1;
                }
            }*/

            l = i+1,r = m;
            int ans2 = i;
            while(l <= r){
                int mid = l+(r-l)/2;
                if(pf[v][mid]-pf[v][i-1] <= k){
                    ans2 = mid;
                    l = mid+1;
                }
                else{
                    r = mid-1;
                }
            }
            //ansdesno = min(ansdesno,ans2);
            int stadesno = min(m,pf[v][i-1]+ans2-pf[v][ans2]);
            int ansdesno = max(i,stadesno);

            //cout << v << " " << i << "  " << anslevo << " " << ansdesno << endl;

            dp[v][anslevo] += dp[v+1][i];
            dp[v][anslevo] %= mod;
            dp[v][ansdesno+1] -= dp[v+1][i];
            dp[v][ansdesno+1] %= mod;
            if(dp[v][ansdesno+1] < 0) dp[v][ansdesno+1] += mod;
        }

        for(int j = 1; j <= m; j++){
            dp[v][j] += dp[v][j-1];
            dp[v][j] %= mod;
        }
    }

    int sol = 0;
    for(int j = 1; j <= m; j++){
        if(a[1][j] == 1) continue;
        sol += dp[2][j];
        sol %= mod;
    }
    cout << sol << endl;
}