#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 2e5+45;

int n,x[N],y[N];
int bitx[N],bity[N];
int stax[N],stay[N];

void updatex(int pos,int val){
    while(pos < N){
        bitx[pos] += val;
        pos += pos & (-pos);
    }
}

int getx(int pos){
    int ret = 0;
    while(pos){
        ret += bitx[pos];
        pos -= pos & (-pos);
    }
    return ret;
}

void updatey(int pos,int val){
    while(pos < N){
        bity[pos] += val;
        pos += pos & (-pos);
    }
}

int gety(int pos){
    int ret = 0;
    while(pos){
        ret += bity[pos];
        pos -= pos & (-pos);
    }
    return ret;
}


int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    vector <pair<int,int>> vx,vy;
    map <int,int> mapx,mapy;
    for(int i = 1; i <= n; i++){
        cin >> x[i] >> y[i];
        if(!mapx.count(x[i])){
            mapx[x[i]] = 1;
            vx.push_back({x[i],i});
        }
        if(!mapy.count(y[i])){
            mapy[y[i]] = 1;
            vy.push_back({y[i],i});
        }
    }

    mapx.clear();
    mapy.clear();
    sort(vx.begin(),vx.end());
    sort(vy.begin(),vy.end());
    int tx = 1,ty = 1;
    for(auto f : vx){
        stax[tx] = f.second;
        mapx[f.first] = tx++;
    }
    for(auto f : vy){
        stay[ty] = f.second;
        mapy[f.first] = ty++;
    }

    for(int i = 1; i <= n; i++){
        x[i] = mapx[x[i]];
        y[i] = mapy[y[i]];
        //cout << x[i] << " " << y[i] << " aa" << endl;
    }

    for(int i = 1; i <= n; i++){
        updatex(x[i],1);
        updatey(y[i],1);

        if(i%2 == 0){
            cout << -1 << endl;
            continue;
        }

        int l = 1,r = n,ansx = 0;
        while(l <= r){
            int mid = l+(r-l)/2;
            if(getx(mid) >= (i+1)/2){
                ansx = mid;
                r = mid-1;
            }
            else{
                l = mid+1;
            }
        }
        assert(ansx);

        l = 1,r = n;
        int ansy = 0;
        while(l <= r){
            int mid = l+(r-l)/2;
            //cout << "sta " << l << " " << r << " " << mid << " y " << gety(mid) << " i " << i << endl;
            if(gety(mid) >= (i+1)/2){
                ansy = mid;
                r = mid-1;
            }
            else{
                l = mid+1;
            }
        }
        assert(ansy);

        //cout << "d " << i << " " << ansx << " " << ansy << endl;

        int ko1 = stax[ansx];
        int ko2 = stay[ansy];

        if(ko1 == ko2){
            cout << ko1 << endl;
        }
        else{
            cout << -1 << endl;
        }
    }
}