#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 2e5+45;

int n;
vector <int> g[N];
int sz[N],parent[N];

void dfssz(int x,int par){
    parent[x] = par;
    for(auto f : g[x]){
        if(f == par) continue;
        dfssz(f,x);
        sz[x] += sz[f];
    }
    sz[x]++;
}

int dfscnt(int x,int par){
    int maxi = 0,koji = 0;
    for(auto f : g[x]){
        if(f == par) continue;
        if(sz[f] > maxi){
            maxi = sz[f];
            koji = f;
        }
    }
    if(maxi <= n/2){
        return x;
    }
    return dfscnt(koji,x);
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 1; i < n; i++){
        int u,v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfssz(1,0);
    int centr = dfscnt(1,0);
    /*cout << centr << endl;
    return 0;*/

    int mini = N,v1 = 0,v2 = 0,cent = 0;
    for(int i = 1; i <= n; i++){
        for(int j = i+1; j <= n; j++){
            if(parent[i] == j || parent[j] == i) continue;

            vector <int> pr = {i,j,centr};
            for(auto c : pr){
                queue <pair<int,int>> q;
                q.push({0,c});
                vector <int> visited(n+1,0);
                visited[c] = 1;
                int mxdist = 0;
                while(!q.empty()){
                    auto tp = q.front();
                    q.pop();
                    int dst = tp.first;
                    mxdist = max(mxdist,dst);
                    int u = tp.second;
                    for(auto f : g[u]){
                        if(!visited[f]){
                            visited[f] = 1;
                            q.push({dst+1,f});
                        }
                    }
                    if(u == i){
                        if(!visited[j]){
                            visited[j] = 1;
                            q.push({dst+1,j});
                        }
                    }
                    if(u == j){
                        if(!visited[i]){
                            visited[i] = 1;
                            q.push({dst+1,i});
                        }
                    }
                }

                if(mxdist < mini){
                    mini = mxdist;
                    v1 = i;
                    v2 = j;
                    cent = c;
                }
            }
        }
    }

    cout << v1 << " " << v2 << endl;
    cout << cent << endl;
    //cout << "a " << mini << endl;
}