#include <bits/stdc++.h>
using namespace std;
#define MOD (long long)(1e9 + 7) i++)
#define RREP(i, a, b) for (int i = a; i >= b; i--)
#define REP(i, a, b) for (int i = a; i < b; i++)
#define endl '\n'
typedef long long ll;

int n, m, k;
char tmpC;
vector<vector<bool>> mat;

void solve(){
    cin >> n >> m >> k;
    mat.resize(n, vector<bool>(m, 0));

    int sum = 0;

    REP(i, 0, n) REP(j, 0, m) {
        cin >> tmpC;
        if (tmpC == '0') mat[i][j] = 0;
        else {
            mat[i][j] = 1;
            sum++;
        }
    }

    if (sum == 0) {
        long long x = 1;
        while (n--) {
            (x *= m) %= MOD;
        }
        cout << x << endl;
        return;
    }

    vector<int> ans(m, 1), tmp(m);
    int seg = 0, tJ;
    RREP(i, n - 1, 1) {
        REP(j, 0, m) tmp[j] = 0;
        // guranje desno
        REP(j, 0, m) {
            if (mat[i][j]) continue;
            tJ = j;
            seg = sum = 0;
            while (mat[i][tJ]) (sum += mat[i][tJ++]) %= MOD;
            if (mat[i][tJ]) --tJ;
            do{
                (tmp[tJ] += ans[j]) %= MOD;
                while (tJ + seg + 1 < m && mat[i][tJ + seg + 1] && seg <= k) ++seg;
                ++tJ;
                //cout << tJ << " " << seg << " " << k << endl;
            }while(tJ + seg < m && seg <= k);
        }
        // guranje levo
        RREP(j, m - 1, 0) {
            if (mat[i][j]) continue;
            tJ = j;
            seg = sum = 0;
            while (mat[i][tJ]) (sum += mat[i][tJ--]) %= MOD;
            if (mat[i][tJ]) ++tJ;
            do{
                (tmp[tJ] += ans[j]) %= MOD;
                while (tJ - seg - 1 >= 0 && mat[i][tJ - seg - 1] && seg <= k) ++seg;
                --tJ;
                //cout << i << " " << tJ << " " << seg << " " << k << endl;
            }while(tJ - seg >= 0 && seg <= k);
        }

        REP(j, 0, m) if (mat[i][j] == 0) ((tmp[j] -= ans[j]) += MOD) %= MOD;

        ans = tmp;
    }

    ll x = 0;
    REP(i, 0, m) if (mat[0][i] == 0) (x += ans[i]) %= MOD;
    cout << x << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;//cin >> t;
    REP(i, 0, t) solve();

    return 0;
}