#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define INF (long long)1e18
#define MOD (long long)(1e9 + 7)
#define sz(x) ((int)x.size())
#define X real()
#define Y imag()
#define F first
#define S second
#define EPS 1e-9
#define PI 3.141592
#define cross(a, b) (conj(a) * b).Y
#define MAN(a, b) norm(a - b)
#define EUC(a, b) abs(a - b)
#define PB push_back
#define REP(i, a, b) for (int i = a; i < b; i++)
#define RREP(i, a, b) for (int i = a; i >= b; i--)
#define heap priority_queue
#define endl '\n'
const double PI2 = acos(0.0);
typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef unsigned short us;
typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

int n;
vector<vector<int>> t;
int mxH, mxI;
vector<int> h;

void dfs(int i, int p) {
    for (int j : t[i]) {
        if (j == p) continue;
        h[j] = h[i] + 1;
        if (h[j] > mxH) {
            mxH = h[j];
            mxI = j;
        }
        dfs(j, i);
    }
}

void solve(){
    cin >> n;

    t.resize(n);
    h.resize(n);
    int a, b;
    REP(i, 0, n - 1) {
        cin >> a >> b;
        --a, --b;

        t[a].PB(b);
        t[b].PB(a);
    }

    long long ansR = -1, ansSum = INF, ansA = -1, ansB = -1, tmpSum;
    REP(i, 0, n) {
        REP(j, 0, n) h[j] = 0;
        mxH = 0;
        mxI = i;
        dfs(i, -1);
        tmpSum = 0;
        REP(j, 0, n) tmpSum += h[j];
        tmpSum -= mxH;
        ++tmpSum;
        if (tmpSum < ansSum){
            ansSum = tmpSum;
            ansA = i, ansB = mxI;
            ansR = i;
        }
    }

    cout << ansA + 1 << " " << ansB + 1 << endl;
    cout << ansR + 1 << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;//cin >> t;
    REP(i, 0, t) solve();

    return 0;
}