#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define INF (long long)1e18
#define MOD (long long)(1e9 + 7)
#define sz(x) ((int)x.size())
#define X real()
#define Y imag()
#define F first
#define S second
#define EPS 1e-9
#define PI 3.141592
#define cross(a, b) (conj(a) * b).Y
#define MAN(a, b) norm(a - b)
#define EUC(a, b) abs(a - b)
#define PB push_back
#define REP(i, a, b) for (int i = a; i < b; i++)
#define RREP(i, a, b) for (int i = a; i >= b; i--)
#define heap priority_queue
#define endl '\n'
const double PI2 = acos(0.0);
typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef unsigned short us;
typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

int n;
vector<vector<int>> t;
int mxH, mxI;
vector<int> h;

void dfs(int i, int p) {
    for (int j : t[i]) {
        if (j == p) continue;
        h[j] = h[i] + 1;
        if (h[j] > mxH) {
            mxH = h[j];
            mxI = j;
        }
        dfs(j, i);
    }
}

void solve(){
    cin >> n;

    t.resize(n);
    h.resize(n);
    int a, b;
    REP(i, 0, n - 1) {
        cin >> a >> b;
        --a, --b;

        t[a].PB(b);
        t[b].PB(a);
    }

    int d = 0, l1 = -1, l2;
    REP(i, 0, n) {
        if (sz(t[i]) > 2) ++d;
        if (sz(t[i]) == 1) {
            if (l1 > -1) l2 = i;
            else l1 = i;
        }
    }

    if (d == 0) {
        //cout << l1 << " " << l2 << endl;
        if (n == 3) {
            cout << l1 + 1 << " " << l2 + 1 << endl;
            cout << l1 + 1 << endl;
        }
        else if (n == 4) {
            l1 = t[l1][0];
            cout << l1 + 1 << " " << l2 + 1 << endl;
            cout << l1 + 1 << endl;
        }
        else {
            n = (n - 2) / 3;
            int p1 = -1, p2 = -1;
            for (int i = 0; i < n; i++) {
                if (t[l1][0] == p1) l1 = t[l1][1];
                else l1 = t[l1][0];
                if (t[l2][0] == p2) l2 = t[l2][1];
                else l2 = t[l2][0];

                p1 = l1, p2 = l2;
            }
            cout << l1 + 1 << " " << l2 + 1 << endl;
            cout << l1 + 1 << endl;
        }
        return;
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;//cin >> t;
    REP(i, 0, t) solve();

    return 0;
}