using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Diagnostics.SymbolStore;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Net.WebSockets;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Schema;
using System.Numerics;
//using System.Data;
//using System.Drawing;

namespace ConsoleApplication1
{
    class Program
    {
        static long dfs(int n, int m, int i, int j, int[,] mat, int[,] preflevo, int[,] prefdesno, int zb, bool[,] vis, int k, bool right, bool left, int mod)
        {
            if (i == 0)
            {
                return 1;
            }
            vis[i, j] = true;
            long zb1 = 0;
            if (j < m - 1 && ((right == false && left == false) || right == true))
            {
                if (mat[i, j] == 1)
                    if (zb + j + 1 < m && prefdesno[i, j + zb + 1] + zb <= k)
                    {
                        if (!vis[i, j + 1])
                            zb1 += dfs(n, m, i, j + 1, mat, preflevo, prefdesno, zb + prefdesno[i, j + zb + 1], vis, k, true, false,mod)%mod;
                        vis[i, j + 1] = false;
                    }
                if (mat[i, j] == 0)
                {
                    if (right == false && left == false)
                        if (j + 1 < m && prefdesno[i, j + 1] <= k && j + prefdesno[i, j + 1] + 1 < m)
                        {
                            if (!vis[i, j + 1])
                                zb1 += dfs(n, m, i, j + 1, mat, preflevo, prefdesno, zb + prefdesno[i, j + 1], vis, k, true, false,mod)%mod;
                            vis[i, j + 1] = false;
                        }
                }
            }
            if (j > 0 && ((right == false && left == false) || left == true))
            {
                if (mat[i, j] == 0)
                {
                    if (right == false && left == false)
                        if (preflevo[i, j - 1] <= k && j - preflevo[i, j - 1] - 1 >= 0)
                        {
                            if (!vis[i, j - 1])
                                zb1 += dfs(n, m, i, j - 1, mat, preflevo, prefdesno, zb + preflevo[i, j - 1], vis, k, false, true,mod)%mod;
                            vis[i, j - 1] = false;

                        }
                }
                else
                {
                    if (j - zb - 1 >= 0)
                        if (preflevo[i, j - zb - 1] + zb <= k)
                        {
                            if (!vis[i, j - 1])
                                zb1 += dfs(n, m, i, j - 1, mat, preflevo, prefdesno, zb + preflevo[i, j - zb - 1], vis, k, false, true,mod)%mod;
                            vis[i, j - 1] = false;

                        }
                }
            }
            if (mat[i - 1, j] == 0)
                if (!vis[i - 1, j])
                {
                    zb1 += dfs(n, m, i - 1, j, mat, preflevo, prefdesno, 0, vis, k, false, false,mod)%mod;
                    vis[i - 1, j] = false;
                }
            return zb1%mod;
        }
        static void Main(string[] args)
        {
            var s = Console.ReadLine().Split();
            int n = int.Parse(s[0]);
            int m = int.Parse(s[1]);
            int k = int.Parse(s[2]);
            int[,] mat = new int[n, m];
            int[,] preflevo = new int[n, m];
            int[,] prefdesno = new int[n, m];
            const int mod = (int)1e9 + 7;
            for (int i = 0; i < n; i++)
            {
                string s1 = Console.ReadLine();
                for (int j = 0; j < m; j++)
                {
                    mat[i, j] = s1[j] - 48;
                }
                if (mat[i, 0] == 1)
                    preflevo[i, 0] = 1;
                if (mat[i, m - 1] == 1)
                    prefdesno[i, m - 1] = 1;
                for (int j = 1; j < m; j++)
                {
                    if (mat[i, j] == 1)
                        preflevo[i, j] = preflevo[i, j - 1] + 1;
                }
                for (int j = m - 2; j >= 0; j--)
                {
                    if (mat[i, j] == 1)
                        prefdesno[i, j] = prefdesno[i, j + 1] + 1;
                }
            }
            long ans = 0;
            bool[,] vis = new bool[n, m];
            for (int i = 0; i < m; i++)
                if (mat[n - 1, i] == 0)
                {
                    ans = (ans+dfs(n, m, n - 1, i, mat, preflevo, prefdesno, 0, vis, k, false, false,mod))%mod;
                }
            Console.WriteLine(ans);
        }
    }
}