#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;

    vector<int> vec(n+1);
    for(int i = 1; i <= n; i++)
    {
        cin >> vec[i];
    }
    int ans = 0;
    vector<pair<int, int>> vecm(m);
    for(int i = 0; i < m; i++)
    {
        int l, r;
        cin >> l >> r;
        vecm[i] = make_pair(l, r);
    }
    vector<int> difference(n+2);
    for(int u = 0; u < m; u++)
    {
        difference[vecm[u].first]++;
        difference[vecm[u].second]--;
    }
    vector<int> prefsum(n+2);
    int tren = 0;
    for(int i = 1; i <= n; i++)
    {
        tren += difference[i];
        prefsum[i] = prefsum[i-1] + (tren > vec[i]);
    }
    //for(int i = 1; i <= n; i++)
    //{
    //    if(prefsum[i] != prefsum[i-1]) cout << i << " ";
    //}
    //cout << endl;

    stable_sort(vecm.begin(), vecm.end(), [&](auto& a, auto& b)
    {
        return (prefsum[a.second] - prefsum[a.first-1]) < (prefsum[b.second] - prefsum[b.first-1]);
    });
    for(int u = 0; u < m; u++)
    {
        int l = vecm[u].first;
        int r = vecm[u].second;
        bool is = false;
        for(int i = l; i <= r; i++)
        {
            if(vec[i] - 1 < 0)
            {
                ans++;
                is = true;
                break;
            }
        }
        if(!is)
        {
            for(int i = l; i <= r; i++)
            {
                vec[i]--;
            }
        }
    }
    cout << ans << endl;




    /*
    stable_sort(vecm.begin(), vecm.end(), [](auto& a, auto& b){
           return (a.second - a.first) >= (b.second - b.first);
    });
    for(int u = 0; u < m; u++){
       int l = vecm[u].first; int r = vecm[u].second;
       bool is = false;
       for(int i = l; i <= r; i++){
           if(vec[i] - 1 < 0){
               ans++;
               is = true;
               break;
           }
       }
       if(!is){
           for(int i = l; i <= r; i++){
               vec[i]--;
           }
       }
    }
    cout << ans << endl;
    */
    return 0;
}