#include <bits/stdc++.h>
using namespace std;

const int N = 200005;

vector<int> graph[N];

int bDist = 0;
vector<int> bdNode;

void getFarthest(int v, int p, int d){
    if(d >= bDist){
        if(d > bDist)
            bdNode.clear();
        bDist = d;
        bdNode.push_back(v);
    }
    for(auto u : graph[v]){
        if(u == p)
            continue;
        getFarthest(u, v, d + 1);
    }
}

int mid = -1;

bool getMid(int v, int goal, int d, int need, int p){
    if(v == goal)
        return true;

    bool fnd = false;
    for(auto u : graph[v]){
        if(u == p)
            continue;
        bool otw = getMid(u, goal, d + 1, need, v);
        fnd |= otw;
        if(otw && d == need){
            mid = v;
        }
    }

    return fnd;
}

int depth[N];

void getDepth(int v, int p, int d){
    depth[v] = d;
    for(auto u : graph[v]){
        if(u == p)
            continue;
        getDepth(u, v, d + 1);
    }
}

int main()
{
    int n;
    cin >> n;
    for(int i = 0; i < n - 1; ++i){
        int x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    bdNode.clear();
    bDist = 0;
    getFarthest(1, -1, 0);

    int x = bdNode[0];
    bDist = 0;
    bdNode.clear();
    getFarthest(x, -1, 0);
    int y = bdNode[0];

    mid = -1;
    getMid(x, y, 0, bDist / 2, -1);

    int root = mid;
    getDepth(root, -1, 0);

    vector<pair<int, int>> deepest;
    for(int i = 1; i <= n; ++i){
        deepest.push_back({depth[i], i});
    }
    sort(deepest.begin(), deepest.end());
    reverse(deepest.begin(), deepest.end());

    cout << deepest[0].second << " " << deepest[1].second << "\n";
    cout << deepest[0].first << "\n";
    return 0;
}