#include <iostream>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>
//find_by_order
//order_of_key
const int N=2e5+5;
int dist[N];
int mx=0,flag=0;
vector<int> g[N],tour;
void dfs(int v,int p,int d){
    dist[v]=d;
    mx=max(mx,d);
    for(int u:g[v]){
        if(u==p)continue;
        dfs(u,v,d+1);
    }
}
void dfs2(int v,int p){
    if(flag)return;
    tour.push_back(v);
    if(dist[v]==mx){
        flag=1;
    }
    if(flag)return;
    for(int u:g[v]){
        if(u==p)continue;
        dfs2(u,v);
    }
    if(!flag)tour.pop_back();
}
int main(){
    int n;scanf("%d",&n);
    for(int i=1,u,v;i<n;i++){
        scanf("%d%d",&u,&v);
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(1,1,0);
    int root=1;
    for(int i=1;i<=n;i++){
        if(dist[i]>dist[root])root=i;
    }
    dfs(root,root,0);
    dfs2(root,root);
    printf("%d %d %d",tour[0],tour.back(),tour[tour.size()/2]);
    return 0;
}