#include <iostream>
#include <queue>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>
//find_by_order
//order_of_key
const int N=2e5+5;
int best=1e9;
int dist[N];
int ans[3];
set<int> g[N];
int main(){
    int n;scanf("%d",&n);
    for(int i=1,u,v;i<n;i++){
        scanf("%d %d",&u,&v);
        g[u].insert(v);
        g[v].insert(u);
    }
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            if(i==j)continue;
            if(g[i].count(j))continue;
            g[i].insert(j);
            g[j].insert(i);
            for(int k=1;k<=n;k++){
                queue<int> q;
                for(int l=1;l<=n;l++)dist[l]=1e9;
                dist[k]=0;
                int cur=0;
                q.push(k);
                for(;!q.empty();){
                    int v=q.front();q.pop();
                    for(int u:g[v]){
                        if(dist[u]>dist[v]+1){
                            dist[u]=dist[v]+1;
                            cur=max(cur,dist[v]);
                            q.push(u);
                        }
                    }
                }
                if(cur<best){
                    ans[0]=i;
                    ans[1]=j;
                    ans[2]=k;
                    best=cur;
                }
            }
            g[i].erase(j);
            g[j].erase(i);
        }
    }
    printf("%d %d\n%d",ans[0],ans[1],ans[2]);
    return 0;
}