#include <iostream>
#include <queue>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>
//find_by_order
//order_of_key
const int N=2e5+5;
int best=1e9;
int dist[N];
int ans[3];
int g[405][405];
vector<int> adj[405];
int main(){
    int n;scanf("%d",&n);
    for(int i=1,u,v;i<n;i++){
        scanf("%d %d",&u,&v);
        g[u][v]=g[v][u]=1;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
    if(n>100)return 0;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            if(i==j)continue;
            if(g[i][j])continue;
            g[i][j]=g[j][i]=1;
            adj[i].push_back(j);
            adj[j].push_back(i);
            for(int k=1;k<=n;k++){
                queue<int> q;
                for(int l=1;l<=n;l++)dist[l]=1e9;
                dist[k]=0;
                int cur=0;
                q.push(k);
                for(;!q.empty();){
                    int v=q.front();q.pop();
                    for(int u:adj[v]){
                        if(dist[u]>dist[v]+1){
                            dist[u]=dist[v]+1;
                            cur=max(cur,dist[v]);
                            q.push(u);
                        }
                    }
                }
                if(cur<best){
                    ans[0]=i;
                    ans[1]=j;
                    ans[2]=k;
                    best=cur;
                }
            }
            g[i][j]=g[j][i]=0;
            adj[i].pop_back();
            adj[j].pop_back();
        }
    }
    printf("%d %d\n%d",ans[0],ans[1],ans[2]);
    return 0;
}