#include <iostream>
#include <vector>
#include <set>
#include <queue>
using namespace std;
//find_by_order
//order_of_key
const int N=2e5+5;
int dist[N];
int par[N];
queue<int> q;
int best=1e9;
int ans[3];
set<int>g[N];vector<int> tour;
void dfs(int v,int p,int d){
    par[v]=p;
    dist[v]=d;
    for(int u:g[v]){
        if(u==p)continue;
        dfs(u,v,d+1);
    }
}
int check(int x,int n){
    for(int i=1;i<=n;i++)dist[i]=1e9;
    dist[x]=0;
    q.push(x);
    int mx=0;
    for(;!q.empty();){
        int v=q.front();q.pop();
        for(int u:g[v]){
            if(dist[u]>dist[v]+1){
                dist[u]=dist[v]+1;
                q.push(u);
                mx=max(mx,dist[u]);
            }
        }
    }
    if(mx<best){
        best=mx;
        return 1;
    }
    return 0;
}
int main(){
    int n;scanf("%d",&n);
    int flag=2;
    for(int i=1,u,v;i<n;i++){
        scanf("%d%d",&u,&v);
        g[u].insert(v);
        g[v].insert(u);
    }
    dfs(1,1,0);
    int root=1;
    for(int i=1;i<=n;i++){
        if(dist[i]>dist[root])root=i;
    }
    dfs(root,root,0);
    int root2=1;
    for(int i=1;i<=n;i++){
        if(dist[i]>dist[root2])root2=i;
    }
    for(;;){
        tour.push_back(root2);
        if(root2==root)break;
        root2=par[root2];
    }
    for(int q=2;q<=5;q++){
    int p=tour.size()/q;
    for(int i=max(0,p-flag);i<=min((int)tour.size()-1,p+flag);i++){
        for(int j=max(0,(int)tour.size()-p-flag);j<=min((int)tour.size()-1,(int)tour.size()-p+flag);j++){
            if(g[tour[i]].count(tour[j]))continue;
            if(i==j)continue;
            g[tour[i]].insert(tour[j]);
            g[tour[j]].insert(tour[i]);
                if(check(tour[i],n)){
                    ans[0]=tour[i];
                    ans[1]=tour[j];
                    ans[2]=tour[i];
                }
                 if(check(tour[j],n)){
                    ans[0]=tour[i];
                    ans[1]=tour[j];
                    ans[2]=tour[j];
                }
            g[tour[i]].erase(tour[j]);
            g[tour[j]].erase(tour[i]);
        }
    }
    }
    printf("%d %d\n%d",ans[0],ans[1],ans[2]);
    return 0;
}