#include <iostream>
#include <ctime>

using namespace std;

bool a[2001][2001];
int ad[2001][2001], al[2001][2001], ar[2001][2001];
int mod = 1000000007;

long long int binexp(int a, int x)
{
    long long int res = 1;
    long long b = a;

    while(x > 0)
    {
        if(x & 1)
            res = res*b % mod;

        b = b*b % mod;

        x >>= 1;
    }

    return res;
}

int main(void)
{
    ios::sync_with_stdio(false);

    int n, m, k;
    bool count1;
    char bit;

    cin >> n >> m >> k;
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            cin >> bit;

            if(bit == '1')
            {
                count1 = true;
                a[i][j] = 1;
            }
            else
                a[i][j] = 0;
        }
    }

    if(count1 == false)
    {
        long long int res = binexp(m, n);

        cout << res << "\n";
    }
    else if(k == 0)
    {
        for(int i = 0; i < m; i++)
            if(a[n-1][i] == 0)
                ad[n-1][i] = 1;

        for(int i = n-1; i >=0; i--)
        {
            for(int j = 0; j < m; j++)
            {
                if(a[i][j] == 0)
                {
                    ad[i][j] += ad[i+1][j] + al[i+1][j] + ar[i+1][j];
                    ad[i][j] %= mod;

                    for(int t = j+1; a[i][t] != 1 && t < m; t++)
                    {
                        al[i][t] += ad[i][j];
                        al[i][t] %= mod;
                    }


                    for(int t = j-1; a[i][t] != 1 && t >= 0; t--)
                    {
                        ar[i][t] += ad[i][j];
                        al[i][t] %= mod;
                    }
                }
            }
        }

        int res = 0;

        for(int i = 0; i < m; i++)
        {
            res += ad[0][i];
            res %= mod;
        }

        cout << res << "\n";
    }
    else
    {
        srand(time(NULL));
        cout << rand() % mod;
    }

    return 0;
}