#include<bits/stdc++.h>
using namespace std;

#define ll long long
const int N = 200001;
int a[N], b[N];
vector<int> seg1[4 * N], seg2[4 * N];
map<int, int> m;

void add1(int u) {
    auto i = seg1[u * 2 + 1].begin();
    auto j = seg1[u * 2 + 2].begin();
    while (i != seg1[u * 2 + 1].end()) {
        if (j == seg1[u * 2 + 2].end()) {
            seg1[u].push_back(*i);
            i++;
            continue;
        }
        if (*i < *j) {
            seg1[u].push_back(*i);
            i++;
            continue;
        }
        seg1[u].push_back(*j);
        j++;
    }
    while (j != seg1[u * 2 + 2].end()) {
        seg1[u].push_back(*j);
        j++;
    }
}

void add2(int u) {
    auto i = seg2[u * 2 + 1].begin();
    auto j = seg2[u * 2 + 2].begin();
    while (i != seg2[u * 2 + 1].end()) {
        if (j == seg2[u * 2 + 2].end()) {
            seg2[u].push_back(*i);
            i++;
            continue;
        }
        if (*i < *j) {
            seg2[u].push_back(*i);
            i++;
            continue;
        }
        seg2[u].push_back(*j);
        j++;
    }
    while (j != seg2[u * 2 + 2].end()) {
        seg2[u].push_back(*j);
        j++;
    }
}

void build(int u, int l, int r) {
    if (l == r) {
        seg1[u].push_back(a[l]);
        seg2[u].push_back(b[l]);
        return;
    }
    int mid = l + r >> 1;
    build(u * 2 + 1, l, mid);
    build(u * 2 + 2, mid + 1, r);
    add1(u);
    add2(u);
}

int nadji1(int u, int l, int r, int L, int R, int br) {
    if (l >= L && r <= R) {
        return seg1[u][br];
    }
    int mid = l + r >> 1;
    if (seg1[u * 2 + 1].size() >= br + 1) {
        return nadji1(u * 2 + 1, l, mid, L, R, br);
    }
    return nadji1(u * 2 + 2, mid + 1, r, L, R, br - seg1[u * 2 + 1].size());
}

int nadji2(int u, int l, int r, int L, int R, int br) {
    if (l >= L && r <= R) {
        return seg2[u][br];
    }
    int mid = l + r >> 1;
    if (seg2[u * 2 + 1].size() >= br + 1) {
        return nadji2(u * 2 + 1, l, mid, L, R, br);
    }
    return nadji2(u * 2 + 2, mid + 1, r, L, R, br - seg2[u * 2 + 1].size());
}


int main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        m.insert({a[i], i + 1});
    }
    build(0, 0, n - 1);
    for (int i = 0; i < n; i++) {
        if (i % 2 == 0) {
            int res = nadji1(0, 0, n - 1, 0, i, i / 2);
            if (res == nadji2(0, 0, n - 1, 0, i, i / 2)) {
                cout << m.find(res) -> second << endl;
                continue;
            }
        }
        cout << -1 << endl;
    }
}