#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <climits>
#include <cmath>
#include <iterator>

using namespace std;

#define sync ios::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define ll long long
#define vi vector<int>
#define all(a) (a).begin(), (a).end()

const int N = 205;
const int K = (1e4)+5;

vector<vi> dp;
int n,m,k;
vi a;
vector<vi> b;


void solve(int i,int s){
    if (s == 0) return;
    for (int l = 0;l<m;l++){
        int r = b[i][l];
        if (s > r){
            if (dp[i][r+1]) continue;
            dp[i][r+1] += (l+1)*a[i];
            if (i+1 < n){
                solve(i+1,s-(r+1));
            }
        }
        else if (i+1<n) solve(i+1,s);
        else break;
    }
}

int main(){
    sync;
    cin >> n >> m >> k;
    a = vi(n);
    dp = vector<vi>(n,vi(k+1));
    for (int& i : a) cin >> i;
    b = vector<vi>(n,vi(m));
    for (int i = 0;i<n;i++){
        for (int j = 0;j<m;j++){
            cin >> b[i][j];
        }
        sort(all(b[i]));
    }
    solve(0,k);
    cout << *max_element(all(dp[0])) << '\n';
}