#include <bits/stdc++.h>

using namespace std;

#define maxN 2000

bool pp[maxN][maxN];

long long vr[maxN][maxN];
long long pref[maxN][maxN];
long long inca[maxN];

vector<vector<long long>> sl;
vector<vector<long long>> slp;
vector<long long> x;

int main()
{
    int n;
    int m;
    int k;

    cin >> n;
    cin >> m;
    cin >> k;


    for(int i = 0; i < n; i++)
    {
        sl.push_back(x);
        slp.push_back(x);

        for(int j = 0; j < m; j++)
        {
            char a;
            cin >> a;

            if(a == '1')
                pp[i][j] = true;
            else
                pp[i][j] = false;
        }
    }

    memset(pref, 0, sizeof(pref));

    for(int i = 0; i < n; i++)
    {
        pref[i][0] = pp[i][0];

        if(!pp[i][0])
            {
                sl[i].push_back(pref[i][0]);
                slp[i].push_back(0);
            }

        for(int j = 1; j < m; j++)
        {
            pref[i][j] = pref[i][j - 1] + pp[i][j];

            if(!pp[i][j])
            {
                sl[i].push_back(pref[i][j]);
                slp[i].push_back(j);
            }
        }
    }



    for(int i = n - 1; i > 0; i--)
    {
        memset(inca, 0, sizeof(inca));

        for(int j = 0; j < sl[i].size(); j++)
        {
            long long  inc;

            if(i == n - 1)
                inc = 1;
            else
                inc = vr[i + 1][slp[i][j]];

            long long  pl = 0;
            long long  pr = 0;

            long long  l = 0;
            long long  r = j;

            while(r >= l)
            {
                long long  mid = l + ((r - l) / 2);

                if(abs(sl[i][j] - sl[i][mid]) <= k)
                {
                    pl = abs(j - mid);
                    r = mid - 1;
                }
                else
                {
                    l = mid + 1;
                }
            }

            l = j + 1;
            r = sl[i].size() - 1;

            while(r >= l)
            {
                long long  mid = l + ((r - l) / 2);

                if(abs(sl[i][j] - sl[i][mid]) <= k)
                {
                    pr = abs(j - mid);
                    l = mid + 1;
                }
                else
                {
                    r = mid - 1;
                }
            }

            inca[slp[i][j] - pl] += inc;
            inca[slp[i][j] + pr + 1] -= inc;

        }

        vr[i][0] = inca[0];

        for(int j = 1; j < m; j++)
            vr[i][j] = inca[j] + vr[i][j - 1];
    }

    long long suma = 0;

    for(int i = 0; i < m; i++)
    {
        if(!pp[0][i])
            suma += (vr[1][i] % 1000000007);

        suma = suma % 1000000007;
    }

    cout << suma << '\n';

    return 0;
}