#include <iostream>
#define MOD 1000000007

using namespace std;

int A[2005][2005];

long long binMod(int a, int s){
    if (s == 1) return a;
    if (s == 0) return 1;
    long long x = binMod(a, s/2);
    if (s % 2 == 0){
        return (x*x)%MOD;
    }
    return (((x*x)%MOD)*x)%MOD;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    string s;
    int n, m, k;
    cin >> n >> m >> k;
    bool p = true;
    for (int i = 1; i <= n; ++i){
        cin >> s;
        for (int j = 1; j <= m; ++j){
            A[i][j] = s[j-1] - '0';
            if (A[i][j] == 1) p = false;
        }
    }
    if (p){
        cout << binMod(m, n);
    }
    else
        cout << 0;
    return 0;
}