#include <iostream>
#define MOD 1000000007

using namespace std;

int A[2005][2005];

long long binMod(long long a, long long s){
    if (s == 1) return a;
    if (s == 0) return 1;
    long long x = binMod(a, s/2);
    if (s % 2 == 0){
        return (x*x)%MOD;
    }
    return (((x*x)%MOD)*a)%MOD;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    string s;
    long long n, m, k;
    cin >> n >> m >> k;
    bool p = true;
    for (int i = 1; i <= n; ++i){
        cin >> s;
        for (int j = 1; j <= m; ++j){
            A[i][j] = s[j-1] - '0';
            if (A[i][j] == 1) p = false;
        }
    }
    if (p){
        cout << binMod(m, n);
    }
    else{
        long long dp[n+1][m+1];
        for (int i = n; i > 1; --i){
            for (int j = 1; j <= m; ++j){
                if (A[i][j] == 0){
                    int l = j;
                    long long sum = 0;
                    while (A[i][j] == 0 && j <= m){
                        if (i != n)
                            sum = (sum + dp[i+1][j]) % MOD;
                        else
                            sum = (sum+1) % MOD;
                        j++;
                    }
                    j--;
                    for (int k = l; k <= j; ++k)
                        dp[i][k] = sum;
                }
                else dp[i][j] = 0;
            }
        }
        long long sumNova = 0;
        for (int i = 1; i <= m; ++i){
            if (A[1][i] == 0) sumNova = (sumNova + dp[2][i]) % MOD;
        }
        cout << sumNova << endl;
    }
    return 0;
}