#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    vector<vector<int>> dp(n, vector<int>(k+1));
    vector<vector<int>> igr(n, vector<int>(m)); 

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> igr[i][j];
        }
    }

    //sortiram
    for (int i = 0; i < n; i++) {
        sort(igr[i].begin(), igr[i].end());
    }

    //uvek proveri da li je broj zetona veci od nule i manji od k+1!

    //popunjavam prvi red
    for (int j = 0; j < m; j++) {
        dp[0][k - igr[0][j] - 1] = (j+1)*s[0];
    }


    for (int i = 1; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int brTokena = igr[i][j] + 1;

            //popunjavam dp
            for (int c = 0; c < i; c++) {
                for (int l = brTokena; l < k + 1; l++) {
                    
                    if (dp[c][l] != 0) {
                        dp[i][l - brTokena] = max(dp[i][l - brTokena], dp[c][l] + s[i] * (j + 1));
                    }
                }
            }
        }
    }

    int maxRes = 0;
    for (int i = 0; i < n; i++) {
        maxRes = max(dp[i][0], maxRes);
    }
    cout << maxRes;
}