#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    vector<vector<long long>> dp(n, vector<long long>(k+1));
    vector<vector<int>> igr(n, vector<int>(m)); 

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> igr[i][j];
        }
    }

    //sortiram
    for (int i = 0; i < n; i++) {
        sort(igr[i].begin(), igr[i].end());
    }

    long long maxRes = 0;

    //popunjavam prvi red
    for (int j = 0; j < m; j++) {
        if (k - igr[0][j] - 1>=0) {
            dp[0][k - igr[0][j] - 1] = (j + 1) * s[0];
            if(dp[0][k - igr[0][j] - 1] > maxRes) maxRes = dp[0][k - igr[0][j] - 1];
        }
    }


    for (int i = 1; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int brTokena = igr[i][j] + 1;

            //popunjavam dp
            for (int c = 0; c < i; c++) {
                for (int l = brTokena; l < k + 1; l++) {
                    
                    if (dp[c][l] != 0) {
                        if (dp[i][l - brTokena] < dp[c][l] + s[i] * (j + 1)) {
                            dp[i][l - brTokena] = dp[c][l] + s[i] * (j + 1);
                        }
                        if(dp[i][l - brTokena]>maxRes) maxRes = dp[i][l - brTokena];
                    }
                    
                }
            }
            
        }
    }

    cout << maxRes;
}