#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
using namespace std;
int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<long long> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    vector<vector<long long>> igr(n, vector<long long>(m)); 

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> igr[i][j];
        }
    }

    if (n == 1) {
        long long out = 0;
        for (int x : igr[0]) {
            if (k > x) out += s[0];
        }
        cout << out;
        return 0;
    }
    if (m == 1) {
        vector<tuple<double,int,int>> vals(n);
        for (int i = 0; i < n; i++) {
            vals[i] = make_tuple((double)s[i] / (double)igr[i][0], igr[i][0], s[i]);
        }
        sort(vals.begin(), vals.end());
        
        long long res = 0;

        int index = n - 1;
        while (k>0) {
            if (index < 0) break;
            tuple<double, int, int> g = vals[index];
            if (k > get<1>(g)) {
                res += get<2>(g);
                k -= get<1>(g);
                index--;
            }
            else {
                index--;
            }

        }
        cout << res;
    }

}