#include <bits/stdc++.h>
#include <time.h>
using namespace std;

#define sz(x) ((int)(x).size())
#define pb push_back
#define vec vector
#define fi first
#define se second
#define ends "\n"
#define sp ' '
#define fun function
#define ar(x) array<int, x>
#define rall(x) (x).rbegin(), (x).rend()
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;

const long long MOD=1e9+7;

void DBG() { cerr << "]" << endl; }
template<class H, class... T> void DBG(H h, T... t) { cerr << to_string(h); if(sizeof...(t)) cerr << ", "; DBG(t...); }
#define dbg(...) cerr << "LINE(" << __LINE__ << ") -> [" << #__VA_ARGS__ << "]: [", DBG(__VA_ARGS__)

long long sum(long long x1, long long x2){
    return ((x1 % MOD) + (x2 % MOD)) % MOD;
}

long long neg(long long x1, long long x2){
    return (((x1 % MOD) - (x2 % MOD))% MOD + MOD) % MOD;
}

int main(void)
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m, k;
    cin >> n >> m >> k;
    vec<string> a(n);
    for(int i = 0; i < n; ++i)
        cin >> a[i];

    vec<vec<vec<ll>>> dp(n + 1, vec<vec<ll>>(m, vec<ll>(3, 0)));
    vec<ll> pref;
    vec<vec<ll>> dp2_0(n), dp2_1(n);
    vec<int> u0(n);

    for(int i = 0; i < n; ++i){
        int cnt_0 = 0, cnt_1 = 0;
        for(int j = 0; j < n; ++j){
            if(a[i][j] == '1'){
                dp2_1[i].pb(cnt_0);
                ++cnt_1;
            }else{
                dp2_0[i].pb(cnt_1);
                ++cnt_0;
            }
        }
    }

    for(int i = 0; i < n; ++i){
        int cnt = 0;
        for(int j = 0; j < m; ++j)
            if(a[i][j] == '0')
                ++cnt;
        u0[i] = cnt;
    }

    fun<bool(int, int, int, int)> check1 = [&] (int ind_0, int i, int cur_ind, int rest_0){
        int real_ind_0 = ind_0 + dp2_0[i][ind_0];
        int dif = cur_ind - real_ind_0 + 1;
        if(rest_0 < dif)
            return false;
        int ind2_0 = (u0[i] - rest_0) + dif - 1;
        int number_1_betw = dp2_0[i][ind2_0] - dp2_0[i][ind_0];
        if(k >= number_1_betw)
            return true;
        return false;
    };

    fun<bool(int, int, int, int)> check2 = [&] (int ind_0, int i, int cur_ind, int rest_0){
        //int real_ind_0 = ind_0 + dp2_0[i][ind_0];
        int real_ind_0 = dp2_0[i][ind_0] + rest_0;
        int dif = real_ind_0 - cur_ind + 1;
        if(rest_0 < dif)
            return false;
        int ind2_0 = (u0[i] - rest_0) + dif - 1;
        int number_1_betw = dp2_0[i][ind_0] - dp2_0[i][ind2_0];
        if(k >= number_1_betw)
            return true;
        return false;
    };

    for(int i = 0; i < m; ++i)
        dp[n][i][0] = 1;

    
    long long ans = 0;
    for(int i = n - 1; i >= 0; ++i){
        if(i == 0){
            for(int j = 0; j < m; ++j){
                ans = sum(ans, dp[1][j][0]);
                ans = sum(ans, dp[1][j][1]);
                ans = sum(ans, dp[1][j][2]);
            }
        }else{
            //left
            int num_0 = 0, num_1 = 0;
            pref.clear();
            pref.pb(0);
            for(int j = 0; j < m; ++j){
                if(a[i][j] == '0'){
                    ++num_0;
                    dp[i][j][0] = sum(dp[i][j][0], dp[i + 1][j][0]);
                    dp[i][j][0] = sum(dp[i][j][0], dp[i + 1][j][1]);
                    dp[i][j][0] = sum(dp[i][j][0], dp[i + 1][j][2]);

                    int left_number_0 = u0[i] - num_0;
                    int lb = 0, rb = sz(pref) - 1;
                    int min_0 = -1;
                    while(lb <= rb){
                        int mb = (lb + rb) / 2;
                        if(check1(mb, i, j, left_number_0)){
                            min_0 = mb;
                            rb = mb - 1;
                        }else{
                            lb = mb + 1;
                        }
                    }

                    if(min_0 != -1)
                        dp[i][j][1] = sum(dp[i][j][1], neg(pref[sz(pref) - 1], pref[min_0]));

                    ll last_num = pref[sz(pref) - 1];
                    pref.pb(sum(last_num, dp[i][j][1]));
                }else{
                    int left_number_0 = u0[i] - num_0;
                    int lb = 0, rb = sz(pref) - 1;
                    int min_0 = -1;
                    while(lb <= rb){
                        int mb = (lb + rb) / 2;
                        if(check1(mb, i, j, left_number_0)){
                            min_0 = mb;
                            rb = mb - 1;
                        }else{
                            lb = mb + 1;
                        }
                    }

                    if(min_0 != -1)
                        dp[i][j][1] = sum(dp[i][j][1], neg(pref[sz(pref) - 1], pref[min_0]));
                }
            }


            num_0 = 0, num_1 = 0;
            pref.clear();
            pref.pb(0);
            for(int j = m - 1; j >= 0; --j){
                if(a[i][j] == '0'){
                    ++num_0;
                    dp[i][j][0] = sum(dp[i][j][0], dp[i + 1][j][0]);
                    dp[i][j][0] = sum(dp[i][j][0], dp[i + 1][j][1]);
                    dp[i][j][0] = sum(dp[i][j][0], dp[i + 1][j][2]);

                    int left_number_0 = u0[i] - num_0;
                    int lb = 0, rb = sz(pref) - 1;
                    int min_0 = -1;
                    while(lb <= rb){
                        int mb = (lb + rb) / 2;
                        if(check2(mb, i, j, left_number_0)){
                            min_0 = mb;
                            rb = mb - 1;
                        }else{
                            lb = mb + 1;
                        }
                    }

                    if(min_0 != -1)
                        dp[i][j][2] = sum(dp[i][j][2], neg(pref[sz(pref) - 1], pref[min_0]));

                    ll last_num = pref[sz(pref) - 1];
                    pref.pb(sum(last_num, dp[i][j][2]));
                }else{
                    int left_number_0 = u0[i] - num_0;
                    int lb = 0, rb = sz(pref) - 1;
                    int min_0 = -1;
                    while(lb <= rb){
                        int mb = (lb + rb) / 2;
                        if(check2(mb, i, j, left_number_0)){
                            min_0 = mb;
                            rb = mb - 1;
                        }else{
                            lb = mb + 1;
                        }
                    }

                    if(min_0 != -1)
                        dp[i][j][2] = sum(dp[i][j][2], neg(pref[sz(pref) - 1], pref[min_0]));
                }
            }


        }
    }

    cout << ans << ends;
}