#include <bits/stdc++.h>
#include <time.h>
using namespace std;

#define sz(x) ((int)(x).size())
#define pb push_back
#define vec vector
#define fi first
#define se second
#define ends "\n"
#define sp ' '
#define fun function
#define ar(x) array<int, x>
#define rall(x) (x).rbegin(), (x).rend()
#define all(x) (x).begin(), (x).end()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int, int> pii;

const long long MOD=1e9+7;

void DBG() { cerr << "]" << endl; }
template<class H, class... T> void DBG(H h, T... t) { cerr << to_string(h); if(sizeof...(t)) cerr << ", "; DBG(t...); }
#define dbg(...) cerr << "LINE(" << __LINE__ << ") -> [" << #__VA_ARGS__ << "]: [", DBG(__VA_ARGS__)
long long sum(long long x1, long long x2){
    return ((x1 % MOD) + (x2 % MOD)) % MOD;
}

int main(void)
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m, k;
    cin >> n >> m >> k;
    vec<string> a(n);
    for(int i = 0; i < n; ++i)
        cin >> a[i];

    long long ans = 0;
    vec<vec<vec<ll>>> dp(n + 1, vec<vec<ll>>(m, vec<ll>(3, 0)));
    for(int j = 0; j < m; ++j)
        dp[n][j][0] = 1;

    if(k == 0){
        for(int i = n - 1; i >= 0; --i){
            if(i == 0){
               for(int j = 0; j < m; ++j){
                    if(a[i][j] == '0'){
                        ans = sum(ans, dp[1][j][0]);
                        ans = sum(ans, dp[1][j][1]);
                        ans = sum(ans, dp[1][j][2]);
                    }
               }
            }else{
                ll sfsum = 0;
                for(int j = 0; j < m; ++j){
                    if(a[i][j] == '1'){
                        sfsum = 0;
                    }else{
                        dp[i][j][0] = sum(sum(dp[i + 1][j][1], dp[i + 1][j][2]), dp[i + 1][j][0]);
                        dp[i][j][1] = sfsum;
                        sfsum = sum(sfsum, dp[i][j][0]);
                    }
                }
                sfsum = 0;
                for(int j = m - 1; j >= 0; --j){
                    if(a[i][j] == '1')
                        sfsum = 0;
                    else{
                        dp[i][j][2] = sfsum;
                        sfsum = sum(sfsum, dp[i][j][0]);
                    }
                }
            }

        }

        cout << ans << ends;
    }else{
        for(int i = n - 1; i >= 0; --i){
            ll sfsum = 0;
            if(i == 0){
               for(int j = 0; j < m; ++j){
                    ans = sum(ans, dp[1][j][0]);
                    ans = sum(ans, dp[1][j][1]);
                    ans = sum(ans, dp[1][j][2]);
               }
            }else{
                for(int j = 0; j < m; ++j){
                    dp[i][j][0] = sum(sum(dp[i + 1][j][1], dp[i + 1][j][2]), dp[i + 1][j][0]);
                    dp[i][j][1] = sfsum;
                    sfsum = sum(sfsum, dp[i][j][0]);
                }
                sfsum = 0;
                for(int j = m - 1; j >= 0; --j){
                    dp[i][j][2] = sfsum;
                    sfsum = sum(sfsum, dp[i][j][0]);
                }
            }

        }

        cout << ans << ends;
    }


}