#include <bits/stdc++.h>
#define ll long long
#define en "\n"
#define mxn 2005
using namespace std;

int n,m,k;
int md = 1e9+7;
char a[mxn][mxn];
int pref0[mxn][mxn],pref1[mxn][mxn],pref[mxn];

int suma(int j1, int j2)
{
    if(j1 == 0) return pref[j2];
    return pref[j2] - pref[j1-1];
}

int broj0(int i, int j1, int j2)
{
    if(j1 == 0) return pref0[i][j2];
    else return pref0[i][j2] - pref0[i][j1-1];
}

int broj1(int i, int j1, int j2)
{
    if(j1 == 0) return pref1[i][j2];
    else return pref1[i][j2] - pref1[i][j1-1];
}

int bs1(int i, int j, int L)
{
    int l = 0, r = j;
    int ans = -1;
    while(l <= r)
    {
        int mid = (l+r)/2;
        if(broj0(i,mid,j) >= L) ans = mid, l = mid + 1;
        else r = mid - 1;
    }
    return ans;
}

int bs2(int i, int j, int L)
{
    int l = j, r = m - 1;
    int ans = -1;
    while(l <= r)
    {
        int mid = (l+r)/2;
        if(broj0(i,j,mid) >= L) ans = mid, r = mid - 1;
        else l = mid + 1;
    }
    return ans;
}

int st(int n, int m, int md)
{
    if(n == 0) return 1;
    if(n == 1) return m;
    ll a = ((ll)m*m)%md;
    ll b = 1;
    if(n%2) b = m;
    ll c = (b*st(n/2,a,md))%md;
    return c;
}

bool moze(int i, int j, int j1)
{
    if(j==j1) return true;
    if(j < j1)
    {
        int L = broj1(i,j,j1);
        if(L==0) return true;
        int j2 = bs1(i,j-1,L);
        if(j2 == -1) return false;
        return broj1(i,j2,j1) <= k;
    }
    int L = broj1(i,j1,j);
    if(L==0) return true;
    int j2 = bs2(i,j+1,L);
    if(j2 == -1) return false;
    return broj1(i,j1,j2) <= k;
}

pair<int,int> bs(int i, int j)
{
    int l=0, r = j;
    int j1 = j;
    while(l <= r)
    {
        int mid = (l+r)/2;
        if(moze(i,j,mid)) j1 = mid, r = mid - 1;
        else l = mid+1;
    }
    l = j, r = m - 1;
    int j2 = j;
    while(l <= r)
    {
        int mid = (l+r)/2;
        if(moze(i,j,mid)) j2 = mid, l = mid + 1;
        else r = mid - 1;
    }
    return make_pair(j1,j2);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    cin >> n >> m >> k;

    bool tc1 = true;

    for(ll i = 0; i < n; i++)
        for(ll j = 0; j < m; j++)
            {
                cin >> a[i][j];
                if(a[i][j] == '1')
                {
                    tc1=0;
                    if(j==0) {pref1[i][j]=1;pref0[i][j]=0;}
                    else {pref1[i][j] = 1 + pref1[i][j-1]; pref0[i][j] = pref0[i][j-1];}
                }
                else{
                    if(j == 0) {pref0[i][j] = 1; pref1[i][j] = 0;}
                    else {pref0[i][j] = 1 + pref0[i][j-1]; pref1[i][j] = pref1[i][j-1];}
                }
            }

    //cout << en;
    /*
    if(tc1)
    {
        cout << st(n,m,md) << en;
        return 0;
    }
    if(k==0)
    {
        vector<ll> pre(m);
        vector<ll> tek(m);
        for(ll j = 0; j < m; j++)
        {
            if(a[n-1][j] == '0') pre[j]=1;
            else pre[j]= 0;
        }

        for(ll i = n - 1; i > 0; i--)
        {
            for(ll j = 0; j < m; j++) tek[j]=0;
            ll j = 0, j1 = 0;
            while(j<m)
            {
            while(a[i][j1] == '0') j1++;
            ll s = 0;
            for(ll t = j; t < j1; t++) s = (s + pre[t]) % md;
            for(ll t = j; t < j1; t++) tek[t] = s;
            while(a[i][j1] == '1') j1++;
            j=j1;
            }
            for(ll j = 0; j < m; j++) pre[j] = tek[j];
        }
        ll s = 0;
        for(ll j = 0; j < m; j++) if(a[0][j] == '0') s = (s + pre[j])%md;
        cout << s << "\n";
        return 0;
    }
*/
    ll pre[mxn],tek[mxn];
    for(int j = 0; j < m; j++)
    {
        if(a[n-1][j] == '0') pre[j]=1;
            else pre[j]= 0;
    }
    for(int i = n - 1; i > 0; i--)
    {
        for(int j = 0; j < m; j++) pref[j] = tek[j] = 0;
        if(a[i][0] == '1') pre[0]=0;
        pref[0]=pre[0];

        for(int j = 1; j < m; j++)
        {
            if(a[i][j] == '1') pre[j]=0;
            pref[j] = (pref[j-1] + pre[j])%md;

        }
        for(int j = 0; j < m; j++)
        {
            pair<int,int> p = bs(i,j);
            tek[j] = suma(p.first,p.second);
        }
        for(int j = 0; j < m; j++)  pre[j]=tek[j];

    }
    int tot = 0;
    for(int j = 0; j < m; j++) if(a[0][j] == '0') tot = (tot + pre[j]) % md;
    cout << tot;
}
/*
5 6 0
010000
000111
010000
110110
100110
*/