#include <iostream>
#include <vector>
#include <cmath>
#include <unordered_map>

long long s(long long n) {
    long long k = 0;
    while (n > 0) {
        k += n%10;
        n /= 10;
    }
    return k;
}

int main()
{
    //primitivno resenje
    std::unordered_map<int, int> k;
    int n, m;
    std::cin >> n >> m;
    std::vector<int> lim;
    for (int i = 0; i < n; i++) {
        int t;
        std::cin >> t;
        lim.push_back(t);
        k[t] = 0;
    }
    int res = 0;
    for (int i = 0; i < m; i++) {
        int l, r, j;
        std::cin >> l >> r;
        l--;
        r--;
        for (j = l; j <= r; j++) {
            k[j]++;
        }
    }
    int max = 0;
    for (int i = 0; i < n; i++) {
        if (max < k[i]-lim[i]) {
            max = k[i] - lim[i];
        }
    }
    if (max < 0) max = 0;
    std::cout << max << std::endl;

    return 0;
}