#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#define ll long long
#define ull unsigned ll

using namespace std;

struct rainRange {
    int l;
    int r;
};

struct target {
    int index;
    ll diff;
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> capacities(n + 1);

    int i;
    int j;
    for(i = 1; i <= n; i++)
        cin >> capacities[i];


    ll sorrow = 0;
    vector<vector<int> > whichHit(n + 1);
    vector<rainRange> rainyDays(m);
    for(i = 0; i < m; i++) {
        cin >> rainyDays[i].l >> rainyDays[i].r;
        if(capacities[rainyDays[i].l] == 0)
            sorrow++;
    }

    cout << sorrow;
    
    return EXIT_SUCCESS;
}