#include <bits/stdc++.h>
using namespace std;

#define MOD 1000000007
#define ll long long

ll n, m, k;
bool mat[2005][2005];
pair<ll, ll> seg[2005][2005];
ll add[2005][2005];
ll res[2005][2005];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m >> k;

    for(ll i = 1; i <= n; ++i){
        for(ll j = 1; j <= m; ++j){
            char c;
            cin >> c;
            if(c == '0'){mat[i][j] = false;}
            else{mat[i][j] = true;}
        }
    }

    queue<ll> pos;
    ll cnt;
    for(ll i = 1; i <= n; ++i){
        while(!pos.empty()){
            pos.pop();
        }
        pos.push(0);
        cnt = 1;

        for(ll j = 1; j <= m; ++j){
            if(mat[i][j]){
                if(cnt == k + 1){
                    pos.pop();
                }
                else{
                    ++cnt;
                }
                pos.push(j);
            }
            else{
                seg[i][j].first = pos.front() + cnt;
            }
        }

        while(!pos.empty()){
            pos.pop();
        }
        pos.push(m + 1);
        cnt = 1;

        for(ll j = m; j >= 1; --j){
            if(mat[i][j]){
                if(cnt == k + 1){
                    pos.pop();
                }
                else{
                    ++cnt;
                }
                pos.push(j);
            }
            else{
                seg[i][j].second = pos.front() - cnt;
            }
        }
    }
    ///kraj pre-processinga

    for(ll j = 1; j <= m; ++j){
        if(!mat[n][j]){
            add[n][j] += 1;
            add[n][j + 1] -= 1;
        }
    }

    ll addcnt;
    for(ll i = n; i > 1; --i){
        addcnt = 0;
        for(ll j = 1; j <= m; ++j){
            addcnt += add[i][j];
            if(addcnt >= MOD){addcnt -= MOD;}

            if(!mat[i][j]){
                res[i][j] = addcnt;
                add[i - 1][seg[i][j].first] += res[i][j];
                if(add[i - 1][seg[i][j].first] >= MOD){add[i - 1][seg[i][j].first] -= MOD;}
                add[i - 1][seg[i][j].second + 1] -= res[i][j];
                if(add[i - 1][seg[i][j].second + 1] < 0){add[i - 1][seg[i][j].second + 1] += MOD;}
            }
        }
    }

    ll resFinal = 0;
    addcnt = 0;
    for(ll j = 1; j <= m; ++j){
        addcnt += add[1][j];
        if(addcnt >= MOD){addcnt -= MOD;}
        if(!mat[1][j]){
            resFinal += addcnt;
            if(resFinal >= MOD){resFinal -= MOD;}
        }
    }

    cout << resFinal << "\n";

    return 0;
}