#include <bits/stdc++.h>
using namespace std;

#define pb push_back

int n;
vector<int> g[200005], g1[200005];
bool visited[200005];
bool exists[405][405];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;

    for(int i = 0; i < n - 1; ++i){
        int u, v;
        cin >> u >> v;

        g[u].pb(v);
        g[v].pb(u);
        if(n <= 400){exists[u][v] = exists[v][u] = true;}
    }

    if(n <= 400){
        int iRan, jRan;
        bool broke = false;
        for(int i = 1; i <= n; ++i){
            for(int j = i + 1; j <= n; ++j){
                if(!exists[i][j]){
                    iRan = i;
                    jRan = j;
                    broke = true;
                    break;
                }
            }
            if(broke){break;}
        }

        int res = 200005;
        int resx, resy, resz;
        for(int i = 1; i <= n; ++i){
            for(int j = i + 1; j <= n; ++j){
                if(!exists[i][j]){
                    g1[i].pb(j);
                    g1[j].pb(i);
                }

                for(int k1 = 0; k1 < 2; ++k1){
                    int k;
                    if(k1 == 0){k = i;}
                    else{k = j;}

                    int resCur = 0;
                    queue<pair<int, int>> q;
                    q.push({k, 0});
                    for(int i = 1; i <= n; ++i){visited[i] = false;}

                    while(!q.empty()){
                        int node = q.front().first;
                        int d = q.front().second;
                        q.pop();
                        if(visited[node]){continue;}
                        visited[node] = true;
                        resCur = max(resCur, d);

                        for(auto c : g[node]){
                            if(!visited[c]){
                                q.push({c, d + 1});
                            }
                        }

                        for(auto c : g1[node]){
                            if(!visited[c]){
                                q.push({c, d + 1});
                            }
                        }
                    }

                    if(resCur < res){
                        res = resCur;
                        if(!exists[i][j]){
                            resx = i;
                            resy = j;
                        }
                        else{
                            resx = iRan;
                            resy = jRan;
                        }
                        resz = k;
                    }
                }

                if(!exists[i][j]){
                    g1[i].clear();
                    g1[j].clear();
                }
            }
        }

        cout << resx << " " << resy << "\n" << resz << "\n";
    }

    return 0;
}