#include<iostream>
#include<stdlib.h>

unsigned long long zbir_cifara(unsigned long long br)
{
    unsigned long long ret = 0;
    while(br > 0)
    {
        ret += br % 10;
        br /= 10;
    }
    return ret;
}

int main()
{
    long long X, Y, A, B;
    long long sn, trazeni;
    long odgovor = -1;

    std::cin >> X >> Y >> A >> B;

    long long brmin = X,
                brmax = Y,
                max_sn,
                min_sn;

    if(A != 0)
    {
        max_sn = (brmax - B) / A;
        min_sn = (brmin - B) / A;
        min_sn = (min_sn > 0)? min_sn : 1;
    }
    else
    {
        if((B >= brmin) && (B <= brmax))
            odgovor =  B;
        std::cout << odgovor;
        return 0;
    }

    if(B > brmax)
    {
        std::cout << odgovor;
        return 0;
    }

    for(unsigned long long i = min_sn; i <= max_sn; i++)
    {
        trazeni = i * A + B;
        if((zbir_cifara(trazeni) == i) && (trazeni >= brmin) && (trazeni <= brmax))
        {
            odgovor = trazeni;
            break;
        }
    }

    std::cout << odgovor;

    return 0;
}