#include<iostream>
#include<stdlib.h>

unsigned int zbir_cifara(unsigned long long br)
{
    unsigned long long ret = 0;
    while(br > 0)
    {
        ret += br % 10;
        br /= 10;
    }
    return ret;
}

int main()
{
    unsigned long long A, B;
    unsigned long long sn, trazeni;
    long long odgovor = -1;

    unsigned long long brmin, brmax, max_sn, min_sn;

    std::cin >> brmin >> brmax >> A >> B;


    if(B > brmax)
    {
        std::cout << odgovor;
        return 0;
    }

    if(A == 0)
    {
        if((B >= brmin) && (B <= brmax))
            odgovor = B;
        std::cout << odgovor;
        return 0;

    }

    unsigned long long tmp = brmax;
    unsigned int br_cifara = 0;
    while(tmp > 0)
    {
        br_cifara++;
        tmp /= 10;
    }

    max_sn = (brmax - B) / A;
    max_sn = (max_sn < (br_cifara*9))? max_sn : (br_cifara*9);
    if(brmin >= B)
        min_sn = (brmin - B) / A;
    else
        min_sn = 0;


    for(unsigned long long i = min_sn; i <= max_sn; i++)
    {
        trazeni = i * A + B;
        unsigned int cifre = zbir_cifara(trazeni);
        if((cifre == i) && (trazeni >= brmin) && (trazeni <= brmax))
        {
            odgovor = trazeni;
            break;
        }
    }

    std::cout << odgovor;

    return 0;
}