#include<iostream>
#include<stdlib.h>
#include<vector>
#include<algorithm>
#include<map>

struct Point {unsigned int i, j;};


//barem radi za N=1 hahah
int main()
{
    unsigned int br_rundi, br_ljudi, br_zetona;
    std::map<float, Point> sve_efikasnosti;

    std::cin >> br_rundi >> br_ljudi >> br_zetona;

    std::vector<std::vector<unsigned int>> runde;
    std::vector<unsigned int> vrednosti_rundi(br_rundi);
    std::vector<unsigned int> moji_zetoni(br_rundi, 0);
    std::vector<unsigned int> pobeda_po_rundi(br_rundi, 0);

    for(int i = 0; i < br_rundi; i++)
    {
        std::cin >> vrednosti_rundi[i];
    }

    for(int i = 0; i < br_rundi; i++)
    {
        runde.push_back(std::vector<unsigned int>());
        for(int j = 0; j < br_ljudi; j++)
        {
            unsigned int temp;
            std::cin >> temp;
            runde[i].push_back(temp);
        }
    }

    std::vector<std::vector<float>> efikasnosti;

    for(int i = 0; i < br_rundi; i++)
    {
        std::sort(runde[i].begin(), runde[i].end());
        efikasnosti.push_back(std::vector<float>(br_ljudi));
        for(int j = 0; j < br_ljudi; j++)
        {
            float ef = ((float)(runde[i][j] + 1))/(vrednosti_rundi[i]*(j+1));
            efikasnosti[i][j] = ef;
            sve_efikasnosti[ef] = {i, j};
        }
    }

    unsigned int preostali_zetoni = br_zetona;
    for(auto& memb : sve_efikasnosti)
    {
        Point indeksi = memb.second;
        float ef = memb.first;
        unsigned int cena = runde[indeksi.i][indeksi.j] + 1;
        unsigned int razlika_cene;
        if(cena > moji_zetoni[indeksi.i])
        {
            razlika_cene = cena - moji_zetoni[indeksi.i];
            if(preostali_zetoni < razlika_cene)
                continue;
            preostali_zetoni -= razlika_cene;
            moji_zetoni[indeksi.i] = cena;
            pobeda_po_rundi[indeksi.i] = indeksi.j + 1;
        }
    }

    unsigned int rezultat = 0;
    for(int i = 0; i < br_rundi; i++)
        rezultat += pobeda_po_rundi[i] * vrednosti_rundi[i];

    //Test
    std::cout << "\n";
    for(int i = 0; i < br_rundi; i++)
    {
        for(int j = 0; j < br_ljudi; j++)
        {
            std::cout << " " << runde[i][j];
        }
        std::cout << " - " << moji_zetoni[i] <<"\n";
    }
    std::cout << "\n";
    for(int i = 0; i < br_rundi; i++)
    {
        for(int j = 0; j < br_ljudi; j++)
        {
            std::cout << " " << efikasnosti[i][j];

        }
        std::cout << "\n";
    }
    std::cout << "\n";
    for(auto& memb : sve_efikasnosti)
    {
        std::cout << memb.first << ", ";
    }
    std::cout << "\n";
    std::cout << rezultat << "\n";

}