#include <bits/stdc++.h>

using namespace std;
long long int typedef li;
const int mod=1000000007;

vector<vector<int>> g(200005);
int dub[200005];

bool nadjen=false;
void put(int p, int q, int s, vector<int> &usta)
{
    usta.push_back(p);
    if (p==s) {nadjen=true; return;}
    for (auto it : g[p]) if (!nadjen && it!=q) put(it,p,s,usta);
    if (!nadjen) usta.pop_back();
}

pair<int,int> tempo;
bitset<200005> notin;
void dfs(int p, int q, int snaga)
{
    if (snaga>=0) notin[p]=1;
    for (auto it : g[p]) if (it!=q) dfs(it,p,snaga-1);
}
int dalj(int p, int q)
{
    dub[p]=dub[q]+1;
    int r=p;
    for (auto it : g[p]) if (it!=q)
    {
        int tmp=dalj(it,p);
        if (!notin[tmp] && dub[tmp]>dub[r]) r=tmp;
    }
    return r;
}
bool check(int root, int snaga, int n, int m)
{
    for (int i=1;i<=n;i++) notin[i]=0;
    dfs(root,-1,snaga);

    bool nuke=true;
    for (int i=1;i<=n;i++) if (!notin[i]) nuke=false;
    if (nuke) return true;

    int a=dalj(root,-1);
    int b=dalj(a,-1);

    vector<int> precnik;
    nadjen=false; put(a,-1,b,precnik);
    tempo={root,precnik[precnik.size()/2]};

    /*cout<<a<<" "<<b<<": ";
    for (auto it : precnik) cout<<it<<","; cout<<endl;*/

    //cout<<root<<" "<<snaga<<": "<<a<<" "<<b<<" : "<<dub[b]-1<<endl;

    return (dub[b]+1)/2<=snaga;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0),cout.tie(0);

    vector<int> precnik;

    int n; cin>>n;
    for (int i=1;i<n;i++)
    {
        int u,v; cin>>u>>v;
        g[u].push_back(v),g[v].push_back(u);
    }

    int a=dalj(1,-1),b=dalj(a,-1);
    put(a,-1,b,precnik);

    int m=precnik.size();
    pair<int,int> ans; int opt=1e9;

    ///prvi slucaj
    int l=0,r=m-1;
    while (r-l>1)
    {
        int mid=(l+r)/2;
        if (check(precnik[mid],mid,n,m)) r=mid;
        else l=mid;
    }
    check(precnik[r],r,n,m);
    if (r<opt) opt=r,ans=tempo;

    ///drugi slucaj
    l=0,r=m-1;
    while (r-l>1)
    {
        int mid=(l+r)/2;
        if (check(precnik[mid],m-mid-1,n,m)) l=mid;
        else r=mid;
    }
    check(precnik[l],m-l-1,n,m);
    if (n-l<opt) opt=m-l-1,ans=tempo;

    //cout<<opt<<endl;
    cout<<ans.first<<" "<<ans.second<<"\n"<<ans.first;
}

/*

8
1 2
2 3
3 4
4 5
5 6
6 7
7 8

*/