#include <bits/stdc++.h>

using namespace std;
long long int typedef li;
const int mod=1000000007;

vector<vector<int>> g(200005);
bitset<200005> vis;
int dub[200005];

int dalj(int p, int q)
{
    dub[p]=dub[q]+q;
    int r=p;
    for (auto it : g[p]) if (it!=q)
    {
        int tmp=dalj(it,p);
        if (dub[tmp]>dub[r]) r=tmp;
    }
    return r;
}

vector<int> precnik; bool nadjen=false;
void put(int p, int q, int s)
{
    precnik.push_back(p);
    if (p==s) {nadjen=true; return;}
    for (auto it : g[p]) if (!nadjen && it!=q) put(it,p,s);
    if (!nadjen) precnik.pop_back();
}

pair<int,pair<int,int>> opt; int optval=1e9;
vector<pair<int,pair<int,int>>> kand;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0),cout.tie(0);

    int n; cin>>n;
    if (n<=100)
    {
        set<pair<int,int>> ima;
        for (int i=1;i<n;i++)
        {
            int u,v; cin>>u>>v;
            g[u].push_back(v),g[v].push_back(u);
            ima.insert({min(u,v),max(u,v)});
        }

        int a=dalj(1,-1),b=dalj(a,-1);
        put(a,-1,b);
        kand.push_back({precnik[1],{precnik[0],precnik[2]}});

        for (int i=1;i<=n;i++)
            for (int j=i+1;j<=n;j++)
                if (!ima.count({i,j})) kand.push_back({i,{i,j}}),kand.push_back({j,{j,i}});

        for (auto it : kand)
        {
            int tmpval=0;
            g[it.second.first].push_back(it.second.second);

            queue<pair<int,int>> bfs;
            bfs.push({it.first,0});
            for (int i=1;i<=n;i++) vis[i]=0;
            while (!bfs.empty())
            {
                int p=bfs.front().first,d=bfs.front().second; bfs.pop();
                if (vis[p]) continue; vis[p]=1;
                tmpval=max(tmpval,d);
                for (auto it : g[p]) bfs.push({it,d+1});
            }

            //cout<<"("<<it.first<<" "<<it.second.first<<" "<<it.second.second<<"): "<<tmpval<<endl;
            if (tmpval<optval) optval=tmpval,opt=it;

            g[it.second.first].pop_back();
        }

        cout<<opt.second.first<<" "<<opt.second.second<<"\n";
        cout<<opt.first;
        return 0;
    }

    if (n>400)
    {
        for (int i=1;i<n;i++)
        {
            int u,v; cin>>u>>v;
            g[u].push_back(v),g[v].push_back(u);
        }

        int a=dalj(1,-1),b=dalj(a,-1);
        put(a,-1,b);

        int A=precnik[n/4+1],B=precnik[n-n/4+1];
        cout<<A<<" "<<B<<"\n"<<A;

        return 0;
    }

    for (int i=1;i<n;i++)
    {
        int u,v; cin>>u>>v;
        g[u].push_back(v),g[v].push_back(u);
    }

    int a=dalj(1,-1),b=dalj(a,-1);
    put(a,-1,b);

    int m=precnik.size();
    kand.push_back({precnik[m/2],{a,b}});

    int k1=m/3,k2=m-m/3;
    for (int i=k1-100;i<=k1+100;i++)
        for (int j=k2-100;j<=k2+100;j++)
            if (0<=i && i<m && 0<=j && j<m && abs(i-j)>1)
                kand.push_back({precnik[i],{precnik[i],precnik[j]}});

    //kand.push_back({precnik[(m+1)/3-1],{precnik[(m+1)/3-1],precnik[m-m/3]}});
    //kand.push_back({precnik[m-(m+1)/3],{precnik[m-(m+1)/3],precnik[m/3-1]}});

    for (auto it : kand)
    {
        int tmpval=0;
        g[it.second.first].push_back(it.second.second);

        queue<pair<int,int>> bfs;
        bfs.push({it.first,0});
        for (int i=1;i<=n;i++) vis[i]=0;
        while (!bfs.empty())
        {
            int p=bfs.front().first,d=bfs.front().second; bfs.pop();
            if (vis[p]) continue; vis[p]=1;
            tmpval=max(tmpval,d);
            for (auto it : g[p]) bfs.push({it,d+1});
        }

        //cout<<"("<<it.first<<" "<<it.second.first<<" "<<it.second.second<<"): "<<tmpval<<endl;
        if (tmpval<optval) optval=tmpval,opt=it;

        g[it.second.first].pop_back();
    }

    cout<<opt.second.first<<" "<<opt.second.second<<"\n";
    cout<<opt.first;


}