#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pdd;

#define ff(i,a,b) for(int i = a; i <= b; i++)
#define fb(i,b,a) for(int i = b; i >= a; i--)
#define trav(a,x) for (auto& a : x)

#define sz(a) (int)(a).size()
#define pb push_back
#define fi first
#define se second
#define lb lower_bound
#define ub upper_bound
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) the number of elements in the os less than k
// *os.find_by_order(k)  print the k-th smallest number in os(0-based)

const int mod = 1000000007;
const int inf = 1e9 + 5;
const int mxN = 2005;

int n, m, k;
string s[mxN];

int dp[mxN][mxN]; // broj nacina da stignem u polje (i, j)

int add(int a, int b){
    a += b;
    if(a >= mod)a -= mod;
    return a;
}
int sub(int a, int b){
    a -= b;
    if(a < 0)a += mod;
    return a;
}
int mul(int a, int b){
    return (1ll * a * b) % mod;
}

int A[mxN][mxN];
int B[mxN][mxN];
void Solve(int i){
    // da ide gore
    ff(j,1,m)if(s[i][j] == '0')dp[i][j] = dp[i + 1][j];

    // da ide levo i desno

    if(i == 1)return;
//
//    cout << "i: " << i << endl;
//    ff(j,1,m)cout << dp[i][j] << " ";
//    cout << '\n';

    ff(j,1,m){
        if(s[i][j] == '1')continue;

        // kome sve dp[i][j] mogu da dodam?

        // prvo svima desno

        int br = 0, poz = j;
        ff(l,j + 1,m){
            br += (s[i][l] == '1');
            if(br <= k)poz = l;
            else break;
        }

        if(br == k + 1)br -= 1;
//
//        cout << "j: " << j << endl;
//        cout << "poz: " << poz << endl;
//        cout << "range: " << j + 1 << " " << poz - br << '\n';
//        cout << endl;


        ff(l,j + 1,poz - br){
            A[i][l] = add(A[i][l], dp[i][j]);
        }

    }
//
//    cout << "A1: " << endl;
//    ff(j,1,m)cout << A[i][j] << " ";
//    cout << endl;

    fb(j,m,1){
        if(s[i][j] == '1')continue;

        int br = 0, poz = j;
        fb(l,j - 1,1){
            br += (s[i][l] == '1');
            if(br <= k)poz = l;
            else break;
        }

        if(br == k + 1)br -= 1;

//        cout << "j: " << j << endl;
//        cout << "poz: " << poz << endl;
//        cout << "range: " << j - 1 << " " << poz + br << '\n';
//        cout << endl;

        fb(l,j - 1,poz + br){
            A[i][l] = add(A[i][l], dp[i][j]);
        }
    }

//
//    cout << "A2: " << endl;
//    ff(j,1,m)cout << A[i][j] << " ";
//    cout << endl;

//
    ff(j,1,m)dp[i][j] = add(dp[i][j], A[i][j]);
////
//    cout << "-------------------------" << endl;
//    cout << endl;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    cin >> n >> m >> k;
    ff(i,1,n)cin >> s[i], s[i] = ' ' + s[i];

    ff(i,1,m)if(s[1][i] == '0')dp[n + 1][i] = 1;

    fb(i,n,1)Solve(i);

    int rez = 0;
    ff(j,1,m)rez = add(rez, dp[1][j]);
////
//    cout << endl;
//    ff(i,1,n){
//        ff(j,1,m)cout << dp[i][j] << " ";
//        cout << '\n';
//    }

    cout << rez << '\n';

    return 0;
}
/*

2 2 0
00
00

3 9 2
010001100
101011010
011101110

// probati bojenje sahovski
*/