#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pdd;

#define ff(i,a,b) for(int i = a; i <= b; i++)
#define fb(i,b,a) for(int i = b; i >= a; i--)
#define trav(a,x) for (auto& a : x)

#define sz(a) (int)(a).size()
#define pb push_back
#define fi first
#define se second
#define lb lower_bound
#define ub upper_bound
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) the number of elements in the os less than k
// *os.find_by_order(k)  print the k-th smallest number in os(0-based)

const int mod = 1000000007;
const int inf = 1e9 + 5;
const int mxN = 200005;

int n;
pii niz[mxN];

int main() {
    cin.tie(0)->sync_with_stdio(0);

    cin >> n;
    ff(i,1,n)cin >> niz[i].fi >> niz[i].se;

    ordered_set<pii> X;
    ordered_set<int> Y;
    ff(i,1,n){
        X.insert({niz[i].fi, i});
        Y.insert(niz[i].se);

        if(i % 2 == 0){
            cout << -1 << '\n';
            continue;
        }

        pii M = *X.find_by_order(sz(X) / 2);

        int y = niz[M.se].se;

        int My = Y.order_of_key(y);
        int Vy = sz(Y) - My - 1;

        cout << (My == Vy ? M.se : -1) << '\n';

    }

    return 0;
}
/*



// probati bojenje sahovski
*/