#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pdd;

#define ff(i,a,b) for(int i = a; i <= b; i++)
#define fb(i,b,a) for(int i = b; i >= a; i--)
#define trav(a,x) for (auto& a : x)

#define sz(a) (int)(a).size()
#define pb push_back
#define fi first
#define se second
#define lb lower_bound
#define ub upper_bound
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) the number of elements in the os less than k
// *os.find_by_order(k)  print the k-th smallest number in os(0-based)

const int mod = 1000000007;
const int inf = 1e9 + 5;
const int mxN = 200005;

int n;

vector<int> g[mxN];
bool bio[mxN];

int par[mxN];
int dist[mxN];
void dfs2(int v, int p){
    par[v] = p;
    for(auto u : g[v]){
        if(u != p){
            dist[u] = dist[v] + 1;
            dfs2(u, v);
        }
    }
}


vector<int> Solve(){
    dfs2(1, -1);

    int mx = 0;
    ff(i,1,n)if(dist[mx] < dist[i])mx = i;

    dfs2(mx, -1);

    int dia = 0;
    ff(i,1,n)if(dist[dia] < dist[i])dia = i;

    vector<int> put;
    for(int A = dia; A != -1; A = par[A])put.pb(A);

    return put;

}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    // da li je root uvek sredina diametra

    cin >> n;
    ff(i,1,n - 1){
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }

    // da li je najbolji root na diametru

    vector<int> put = Solve();
    int len = sz(put);
//
//    int mx1 = put[0];
//    int mx2 = put.back();
//
//    bfs(mx1, dmx1);
//    bfs(mx2, dmx2);

    // znam da su kandidati oni na diametru

    if(len == 3){

        cout << put[0] << " " << put.back() << '\n';
        cout << put[1] << '\n';
        return 0;

    }

    int X = (len + 3) / 4;

    int A = put[X];
    int B = put[len - X];

    cout << A << " " << B << '\n';
    cout << A << '\n';

    return 0;
}
/*

5
1 2
2 3
3 4
4 5

// probati bojenje sahovski
*/