#include <bits/stdc++.h>
using namespace std;

void swap(int* a, int* b)
{
    int t = *a;
    *a = *b;
    *b = t;
}
 
int partition (int arr[], int low, int high)
{
    int pivot = arr[high]; 
    int i = (low - 1); 
 
    for (int j = low; j <= high - 1; j++)
    {

        if (arr[j] < pivot)
        {
            i++;
            swap(&arr[i], &arr[j]);
        }
    }
    swap(&arr[i + 1], &arr[high]);
    return (i + 1);
}
 

void quickSort(int arr[], int low, int high)
{
    if (low < high)
    {
        
        int pi = partition(arr, low, high);
 
        
        quickSort(arr, low, pi - 1);
        quickSort(arr, pi + 1, high);
    }
}
 

void printArray(int arr[], int size)
{
    int i;
    for (i = 0; i < size; i++)
        cout << arr[i] << " ";
    cout << endl;
}
 
int main()
{
    int N,M; cin>>N>>M;
    int a[N];
    int r[M], l[M];
    int br[N];
    int q=0;
    for(int i=0; i<N; i++){
        cin>>a[i];
        br[i]=0;
    }
    for(int i=0; i<M; i++){
        cin>>l[i]>>r[i];
    }
    quickSort(l, 0, M - 1);
    quickSort(r, 0, M - 1);
    int br31=0;
    br[0]=1;
    for(int i=0; i<M-1; i++){
        for(int j=i+1; j<M; j++){
            if(r[i]==r[j]){
                br[i]++;
            }
        }
    }
    
    for(int i=0 ;i<M; i++){
        if(br[i]-a[i]>0){
            br31+=br[i]-a[i];
        }
    }
    cout<<br31;
    
}