#include<bits/stdc++.h>
#define int long long
#define MAXEL 1000000007

using namespace std;

bool cmp(pair<int,int> p1, pair<int,int> p2){
    if(p1.first>p2.first && p1.second>p2.second){
        return 0;
    }
    if(p1.first>=p2.first && p1.second<=p2.second){
        return 1;
    }
    if(p1.first<=p2.first && p1.second>=p2.second){
        return 0;
    }
    if(p1.first<p2.first && p1.second<p2.second){
        return 1;
    }
}
int lazy[525000]={0};
int pow2(int k){
    if(k==1){
        return 1;
    }
    return 2*pow2((k+1)/2);
}
void buildTree(int *tree,int *a,int start,int ending,int node){
	if(start==ending)tree[node]=a[start];
	else if(start<ending){
		int mid=(start+ending)/2,left=2*node+1,right=left+1;
		buildTree(tree,a,start,mid,left);
		buildTree(tree,a,mid+1,ending,right);
		tree[node]=min(tree[left],tree[right]);
	}
}
void update(int *tree,int start,int ending,int l,int r,int dif,int node){
	if(lazy[node]!=0){
		tree[node]+=lazy[node];
		if(start!=ending){
			lazy[2*node+1]+=lazy[node];
			lazy[2*node+2]+=lazy[node];
		}
		lazy[node]=0;
	}
	if(start> r || ending<l)return;
	else if(start>=l && ending<=r){
		tree[node]+=dif;
		if(start!=ending){
			lazy[2*node+1]+=dif;
			lazy[2*node+2]+=dif;
		}
		return;
	}
	int mid=(start+ending)/2;
	update(tree,start,mid,l,r,dif,2*node+1);
	update(tree,mid+1,ending,l,r,dif,2*node+2);
	tree[node]=min(tree[2*node+1],tree[2*node+2]);
}
int queryMin(int *tree,int start,int ending,int l,int r,int node){
	if(lazy[node]!=0){
		tree[node]+=lazy[node];
		if(start!=ending){
			lazy[2*node+1]=lazy[node];
			lazy[2*node+2]=lazy[node];
		}
		lazy[node]=0;
	}
	if(start>r || ending<l)return MAXEL-1;
	else if(start>=l && ending<=r)return tree[node];
	else{
		int mid=(start+ending)/2,left=2*node+1,right=left+1;
		return min(queryMin(tree,start,mid,l,min(mid,r),left),queryMin(tree,mid+1,ending,max(mid+1,l),r,right));
	}
}
signed main(){
	int n,i,tree_size;
	cin>>n;
	int p=pow2(n);
	tree_size=2*p;
	int a[p];
	int tree[tree_size];
	int m;
	cin>>m;
	pair<int,int> edges[m];
	for(i=0;i<n;i++){
        cin>>a[i];
    }
    for(i=n;i<p;i++){
        a[i]=MAXEL;
    }
	for(i=0;i<m;i++){
        cin>>edges[i].first>>edges[i].second;
    }
    sort(edges,edges+m,cmp);
    int cnt=0;
	buildTree(tree,a,0,p-1,0);
	for(int i=0;i<m;i++){
		int l=edges[i].first;
		int r=edges[i].second;
		if(queryMin(tree,0,p-1,l-1,r-1,0)==0){
            cnt++;
        }
		else
		{
			update(tree,0,p-1,l-1,r-1,-1,0);
		}
	}
	cout<<cnt;
}