#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 10;
int n;
vector<int> g[N];
int rez = 1e9;
int mx = 0;
bool mark[N];
int dist[N];
int x1, x2, x3;

void bfs(int u) {
    queue<int> q;
    q.push(u);
    while(!q.empty()) {
        int x = q.front();
        q.pop();
        if(mark[x]) continue;
        mark[x] = true;
        for(int v : g[u]) {
            dist[v] = min(dist[v], dist[u] + 1);
            if(mark[v]) continue;
            q.push(v);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for(int i = 1; i <= n; i++) {
        for(int j = i + 1; j <= n; j++) {
            fill(mark + 1, mark + n + 1, false);
            fill(dist + 1, dist + n + 1, 1e9);
            dist[i] = 0;
            g[i].push_back(j);
            g[j].push_back(i);
            bfs(i);
            if(rez > mx) {
                x1 = i;
                x2 = j;
                x3 = i;
            }
            for(int k = i; k <= n; k++) mx = max(mx, dist[k]);
            rez = min(rez, mx);
            fill(mark + 1, mark + n + 1, false);
            fill(dist + 1, dist + n + 1, 1e9);
            dist[j] = 0;
            bfs(j);
            if(rez > mx) {
                x1 = i;
                x2 = j;
                x3 = j;
            }
            rez = min(rez, mx);
            g[i].pop_back();
            g[j].pop_back();
        }
    }
    cout << x1 << " " << x2 << "\n" << x3;
    return 0;
}