#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 10;
int n;
vector<int> g[N];
int rez = 1e9;
int mx = 0;
bool mark[N];
int dist[N];
int x1, x2, x3;

void bfs(int u) {
    queue<int> q;
    q.push(u);
    mark[u] = true;
    while(!q.empty()) {
        int x = q.front();
        q.pop();
        mark[x] = true;
        for(int v : g[x]) {
            if(mark[v]) continue;
            mark[v] = true;
            dist[v] = min(dist[v], dist[x] + 1);
            q.push(v);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for(int i = 1; i <= n; i++) {
        for(int j = i + 1; j <= n; j++) {
            g[i].push_back(j);
            g[j].push_back(i);
            for(int k = 1; k <= n; k++) {
                mx = 0;
                for(int l = 1; l <= n; l++) {
                    dist[l] = 1e9;
                    mark[l] = false;
                }
                dist[k] = 0;
                bfs(k);
                for(int l = 1; l <= n; l++) mx = max(mx, dist[l]);
                if(rez > mx) {
                    x1 = i;
                    x2 = j;
                    x3 = k;
                }
                rez = min(rez, mx);
            }
            g[i].pop_back();
            g[j].pop_back();
        }
    }
    cout << x1 << " " << x2 << "\n" << x3;
    return 0;
}