#include <bits/stdc++.h>

#define ll long long

using namespace std;

const ll LINF = 4e18;
const int mxN = 2e3+10, INF = 2e9, mod = 1e9+7;
int n, m, c, a[mxN][mxN], pre[mxN][mxN], in[mxN][mxN];
ll cnt[mxN][mxN];

ll add(ll a, ll b){ if (a < 0) a += mod; if (b < 0) b += mod; ll x = a + b; if (x >= mod) x -= mod; return x; }
#define sadd(a, b) a = add(a, b)

int sum(int i, int l, int r){ if (r < 0 || l > m-1) return 0; return pre[i][r] - (l ? pre[i][l-1] : 0); }
int free(int i, int l, int r){ if (r < 0 || l > m-1) return 0; return r-l+1-sum(i,l,r); }

int getZ(int i, int x){
    if (x <= 0 || x > free(i, 0, m-1)) return -1;
    return in[i][x];
}

int BSl(int i, int j){

    int l = 0, r = j-1, ans = j;
    while (l <= r){
        int k = (l + r + 1) / 2;
        int s = sum(i, k, j);
        int t = getZ(i, s + free(i, 0, j));
        if (free(i, j+1, m-1) >= s && sum(i, k, t-1) <= c){
            ans = k;
            r = k - 1;
        }
        else l = k + 1;
    }
    return ans;
}

int BSr(int i, int j){

    int l = j+1, r = m-1, ans = j;
    while (l <= r){
        int k = (l + r + 1) / 2;
        int s = sum(i, j, k);
        int t = getZ(i, free(i, 0, j-1) - s + 1);
        if (free(i, 0, j-1) >= s && sum(i, t+1, k) <= c){
            ans = k;
            l = k + 1;
        }
        else r = k - 1;
    }
    return ans;
}

void Solve(){

    cin >> n >> m >> c;
    for (int i = 0; i < n; i++){
        string s; cin >> s;
        for (int j = 0; j < m; j++)
            a[i][j] = (int)(s[j] - '0');
    }
    for (int i = 0; i < n; i++){
        pre[i][0] = a[i][0];
        for (int j = 1; j < m; j++)
            pre[i][j] = pre[i][j-1] + a[i][j];
    }
    for (int i = 0; i < n; i++)
        for (int j = 0, t = 1; j < m; j++)
            if (!a[i][j]) in[i][t++] = j;
    for (int j = 0; j < m; j++)
        cnt[n][j] = 1;
    for (int i = n-1; i; i--){
        for (int j = 0; j < m; j++){
            if (a[i][j]) cnt[i+1][j] = 0;
            if (j) sadd(cnt[i+1][j], cnt[i+1][j-1]);
        }
        for (int j = 0; j < m; j++){
            int l = BSl(i, j), r = BSr(i, j);
            cnt[i][j] = add(cnt[i+1][r], -(l ? cnt[i+1][l-1] : 0));
        }
    }
    ll ans = 0;
    for (int j = 0; j < m; j++)
        if (!a[0][j]) sadd(ans, cnt[1][j]);
    cout << ans << '\n';
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);

    Solve();

    return 0;
}