#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define fi first
#define se second
#define en '\n'
#define sp ' '
#define tb '\t'
#define ri(n) int n; cin >> n
#define rl(n) ll n; cin >> n
#define rs(s) string s; cin >> s
#define rc(c) char c; cin >> c
#define rv(v) for (auto &x : v) cin >> x
#define pven(v) for (auto x : v) cout << x << en
#define pv(v) for (auto x : v) cout << x << sp; cout << en
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define yes cout << "YES" << en
#define no cout << "NO" << en
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
#define ssort(a, b) if (a < b) swap(a, b)
#define bitcnt(a) __builtin_popcountll(a)
#define bithigh(a) 63-__builtin_clzll(a)
#define lg bithigh
ll highpow(ll a) { return 1LL << (ll)lg(a); }

using namespace std;

const ll LINF = 4e18;
const int mxN = 2e5+10, INF = 2e9;
ll n, m, d[mxN], par[mxN];
vector<int> g[mxN];

void dfs1(int s, int p = -1, int dist = 0){

    d[s] = dist;
    par[s] = p;
    for (int u : g[s])
        if (u^p)
            dfs1(u, s, dist+1);
}

int dfs2(int s, int p, int u){

    int mx = d[s];
    for (int v : g[s])
        if (v^p && v^u)
            smax(mx, dfs2(v, s, u));
    return mx;
}

int dfs3(int s, int p){

    int mx = d[s];
    for (int u : g[s])
        if (u^p)
            smax(mx, dfs3(u, s));
    return mx;
}

void Solve1(){

    array<int, 3> ans;
    ans[0] = INF;
    for (int s = 0; s < n; s++){
        dfs1(s);
        for (int u = 0; u < n; u++){
            if (u^s && par[u]^s){
                int sol = dfs3(u, par[u]) + 1;
                smax(sol, dfs2(s, -1, u));
                if (sol < ans[0]) ans = {sol, u, s};
            }
        }
    }
    cout << ans[1] << sp << ans[2] << en << ans[2] << en;
}

int _dfsSub(int s, int p, int d){

    if (d == n/3) return s;
    for (int u : g[s])
        if (u^p)
            return _dfsSub(u, s, d+1);
}

void Solve(){

    cin >> n;
    for (int i = 0; i < n-1; i++){
        ri(u); ri(v);
        u--; v--;
        g[u].pb(v);
        g[v].pb(u);
    }
    bool f = 0;
    for (int i = 0; i < n; i++)
        if (g[i].size() > 2) f = 1;
    if (f){ Solve1(); return; }
    int s = -1, p = -1;
    for (int i = 0; i < n; i++)
        if (g[i].size() == 1) s = i;
    vector<int> v = {s};
    while (g[s].size() == 2 || !~p){
        int u = g[s][0];
        if (u == p) u = g[s][1];
        v.pb(u);
        p = s;
        s = u;
    }
    s = _dfsSub(v[0], -1, 0);
    cout << s << sp << v.back() << en << s << en;
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);
    cout << setprecision(12) << fixed;
    cerr << setprecision(12) << fixed;
    cerr << "Started!" << endl;

    int t = 1;
    //cin >> t;
    while (t--)
        Solve();

    return 0;
}