#include<bits/stdc++.h>
#define xx first
#define yy second
#define pb push_back

using namespace std;

typedef long long ll;

int n;
int kolko[200003], koji, onaj, ovaj, dok[402], raz[402][402];
int zapl, zapm, zapi;
vector<int> graf[200003];
map<pair<int, int>, bool> ima;
int node, par, dub;
void dubine(int cvor, int rod, int kol) {
    dok[cvor]=kol;
    for(auto adj:graf[cvor]) {
        if(adj==rod) continue;
        dubine(adj, cvor, kol+1);
    }
}
void razd(int cvor, int rod) {
    queue<pair<int, pair<int, int>>> q;
    q.push({cvor, {rod, 0}});
    while(!q.empty()) {
        pair<int, pair<int, int>> tren=q.front(); q.pop();
        raz[cvor][tren.xx]=raz[tren.xx][cvor]=tren.yy.yy;
        for(auto adj:graf[tren.xx]) {
            if(adj==tren.yy.xx) continue;
            q.push({adj, {tren.xx, tren.yy.yy+1}});
        }
    }
}
void dfs() {
    while(true) {
        if(dub==(n-1)/4+1 && onaj==0) {
            onaj=node;
        }
        else if(dub==3*((n-1)/4+1) && n!=4) {
            ovaj=node;
            break;
        }
        bool usao=false;
        for(auto adj:graf[node]) {
            if(adj==par) continue;
            usao=1;
            dub++; par=node; node=adj;
            break;
        }
        if(!usao) break;
        if(dub>=n) break;
    }
    if(ovaj==0) ovaj=node;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    bool sluc=true;
    for(int i=1; i<n; i++) {
        int u, v; cin >> u >> v;
        kolko[u]++; kolko[v]++;
        if(kolko[u]>2 || kolko[v]>2) sluc=false;
        graf[u].pb(v); graf[v].pb(u);
        ima[{u, v}]=1; ima[{v, u}]=1;
    }
    if(sluc) {
        for(int i=1; i<=n; i++) {
            if(kolko[i]==1) {
                koji=i;
                break;
            }
        }
        node=koji; par=-1; dub=1;
        dfs();
        if(n==3) {
            for(auto adj:graf[graf[koji][0]]) {
                if(adj==koji) continue;
                cout << adj << ' ' << koji << "\n" << koji;
                return 0;
            }
        }
        if(n==4) {
            cout << graf[koji][0] << ' ' << ovaj << "\n" << graf[koji][0];
            return 0;
        }
        cout << onaj << ' ' << ovaj << "\n" << ovaj;
    }
    else {
        for(int i=1; i<=n; i++) {
            razd(i, -1);
        }
        int glob=2000000000;
        for(int k=1; k<=n; k++) {
            dubine(k, -1, 0);
            for(int l=1; l<=n; l++) {
                for(int m=l+1; m<=n; m++) {
                    if(ima[{l, m}]) continue;
                    int maxi=0;
                    for(int i=1; i<=n; i++) {
                        maxi=max(maxi, min(dok[i], min(raz[i][l]+1+dok[m], raz[i][m]+1+dok[l])));
                    }
                    if(maxi<glob) {
                        glob=maxi;
                        zapl=l;
                        zapm=m;
                        zapi=k;
                    }
                }
            }
        }
        cout << zapl << ' ' << zapm << "\n" << zapi;
    }
    return 0;
}