#include<iostream>
#include<algorithm>
#include<vector>
#define ll long long

using namespace std;

int n;

struct point
{
    ll x;
    ll y;
};

struct vec
{
    ll p1;
    ll p2;
};

ll tree[800006];

void update(ll indx, ll v, int l, int r, int curr)
{
    if(l==r)
    {
        tree[curr]=v;
        return;
    }
    int s=(l+r)/2;
    if(indx<=s)
    {
        tree[curr]++;
        update(indx, v, l, s, 2*curr);
        return;
    }
    update(indx,v,s+1,r,2*curr+1);
}

ll query(ll br, int l, int r, int curr)
{
    if(l==r)
        return tree[curr];
    int s=(l+r)/2;
    if(br<=tree[curr])
        return query(br,l,s, curr*2);
    return query(br-tree[curr], s+1,r, curr*2+1);
}

int main()
{
    cin>>n;
    point tacke[n];
    for(int i=0; i<n; i++)
    {
        cin>>tacke[i].x>>tacke[i].y;
    }
    if(n<5000)
    {
        vec p[n];
        for(int i=0; i<n; i++)
        {
            p[i].p1=0;
            p[i].p2=0;

            for(int j=0; j<i; j++)
            {
                vec a;
                a.p1=0;
                a.p2=0;
                if(tacke[i].x>tacke[j].x && tacke[i].y>tacke[j].y)
                {
                    a.p1=1;
                    a.p2=0;
                }
                else if(tacke[i].x<tacke[j].x && tacke[i].y<tacke[j].y)
                {
                    a.p1=-1;
                    a.p2=0;
                }
                else if(tacke[i].x>tacke[j].x && tacke[i].y<tacke[j].y)
                {
                    a.p1=0;
                    a.p2=1;
                }
                else if(tacke[i].x<tacke[j].x && tacke[i].y>tacke[j].y)
                {
                    a.p1=0;
                    a.p2=-1;
                }
                p[i].p1+=a.p1;
                p[i].p2+=a.p2;
                p[j].p1-=a.p1;
                p[j].p2-=a.p2;
            }
            bool d=false;
            for(int t=0; t<=i; t++)
            {
                if(p[t].p1==0 && p[t].p2==0){
                    cout<<t+1<<endl;
                    d=true;
                    break;
                }
            }
            if(d)
                continue;
            cout<<-1<<endl;
        }
        return 0;
    }
    vector<pair<ll,ll>> br(n);
    for(int i=0; i<n; i++)
    {
        br[i].first=tacke[i].x;
        br[i].second=i;
    }
    sort(br.begin(),br.end());
    for(int i=0; i<n; i++)
    {
        br[i].first=i;
    }
    int s[n];
    for(int i=0; i<n; i++)
    {
        s[br[i].second]=br[i].first;
    }
    for(int i=0; i<4*n; i++)
        tree[i]=0;
    for(int i=0; i<n; i++)
    {
        update(s[i], i, 0, n-1, 1);
        if(i%2)
        {
            cout<<-1<<endl;
            continue;
        }
        cout<<query(i/2+1, 0, n-1, 1)+1<<endl;
    }
}