#include <bits/stdc++.h>
using namespace std;

const int N = 2000;
const int MOD = 1000000007;

int add(int a, int b){ a += b; if(a >= MOD) a -= MOD; return a; }
int sub(int a, int b){ return add(a, MOD - b); }

int mat[N+5][N+5];
int dp[N+5][N+5][2];
int sl[N+5][N+5];
int sd[N+5][N+5];
int pref[N+5];

vector <pair <int, int>> lcomps[N+5];
vector <pair <int, int>> rcomps[N+5];

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);

    int n, m, k;
    cin >> n >> m >> k;
    for(int i=n; i>=1; i--){
        string s;
        cin >> s;
        for(int j=1; j<=m; j++) mat[i][j] = 1 - (s[j-1] - '0');
    }
    for(int i=1; i<=n; i++){
        for(int j=1; j<=m; j++){
            if(!mat[i][j]){
                if(j > 1 && !mat[i][j-1]){
                    lcomps[i].back().second++;
                }
                else{
                    lcomps[i].push_back({j, 1});
                }
            }
        }
        lcomps[i].push_back({m+1, 2*N});
        for(int j=m; j>=1; j--){
            if(!mat[i][j]){
                if(j < m && !mat[i][j+1]){
                    rcomps[i].back().second++;
                }
                else{
                    rcomps[i].push_back({j, 1});
                }
            }
        }
        rcomps[i].push_back({0, 2*N});
        reverse(rcomps[i].begin(), rcomps[i].end());
        //for(auto c : rcomps[i]) cout << c.first << " " << c.second << endl;
        //cout << endl;
    }
    //return 0;
    for(int j=1; j<=m; j++) if(mat[1][j]) dp[1][j][0] = 1;
    for(int i=1; i<n; i++){
        for(int j=1; j<=m; j++) pref[j] = 0;
        //for(int j=1; j<=m; j++) cout << dp[i][j][0] << " ";
        //cout << endl;
        /// desno
        int dl = 0, dr = 0;
        int used = 0;
        for(int j=1; j<=m; j++){
            if(!mat[i][j]) continue;
            while(lcomps[i][dl].first < j){
                used -= lcomps[i][dl].second;
                dl++;
            }
            while(lcomps[i][dr].first < j){
                used += lcomps[i][dr].second;
                dr++;
            }
            while(lcomps[i][dr].second + used <= k){
                used += lcomps[i][dr].second;
                dr++;
            }
            int d = lcomps[i][dr].first - used;
            if(j+1 < d){
                pref[j+1] = add(pref[j+1], dp[i][j][0]);
                pref[d] = sub(pref[d], dp[i][j][0]);
            }
        }
        /// levo
        dl = rcomps[i].size() - 1;
        dr = dl;
        used = 0;
        for(int j=m; j>=1; j--){
            if(!mat[i][j]) continue;
            while(rcomps[i][dr].first > j){
                used -= rcomps[i][dr].second;
                dr--;
            }
            while(rcomps[i][dl].first > j){
                used += rcomps[i][dl].second;
                dl--;
            }
            while(rcomps[i][dl].second + used <= k){
                used += rcomps[i][dl].second;
                dl--;
            }
            int d = rcomps[i][dl].first + used;
            if(d+1 < j){
                pref[d+1] = add(pref[d+1], dp[i][j][0]);
                pref[j] = sub(pref[j], dp[i][j][0]);
            }
        }
        /// dole
        int sum = 0;
        for(int j=1; j<=m; j++){
            sum = add(sum, pref[j]);
            dp[i][j][1] = sum;
        }
        for(int j=1; j<=m; j++) if(mat[i+1][j]) dp[i+1][j][0] = add(dp[i+1][j][0], add(dp[i][j][1], dp[i][j][0]));
    }
    int res = 0;
    for(int j=1; j<=m; j++) res = add(res, dp[n][j][0]);
    cout << res << "\n";
    return 0;
}