#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long

using namespace std;

void solve()
{
    bool prvi = true, treci = true;
    int n, m; cin >> n >> m;
    vector<ll> a(n);
    for(auto& i : a) {
        cin >> i;
        if(i != 0 && i != 1000000000) treci = false;
    }
    vector<pair<int,int>> qs(m);
    for(auto& i : qs) {
        cin >> i.first >> i.second;
        if(i.first != i.second) prvi = false;
    }
    if(prvi) {
        vector<ll> b(n, 0);
        ll br = 0;
        for(auto i : qs) {
            b[i.first - 1]++;
            if(b[i.first - 1] > a[i.first - 1]){
                b[i.first - 1]--;
                br++;
            }
        }
        cout << br << endl;
    }
    else if(treci) {
        vector<ll> zeros_until(n + 1, 0);
        for(int i=0;i<n;i++){
            zeros_until[i+1] = zeros_until[i] + (a[i] == 0);
        }
        int br = 0;
        for(auto i : qs) {
            br += (zeros_until[i.second] - zeros_until[i.first - 1]) > 0;
        }
        cout << br << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}