#include <bits/stdc++.h>

#define ll long long
#define MOD 1000000007
#define MAXN 2020

using namespace std;

ll add(ll x, ll y)
{
    ll ret=x+y;
    if (ret>=MOD) ret-=MOD;
    return ret;
}
ll sub(ll x, ll y)
{
    ll ret=x-y;
    if (ret<0) ret+=MOD;
    return ret;
}
ll mul(ll x, ll y)
{
    ll ret=x*y;
    if (ret>=MOD) ret%=MOD;
    return ret;
}

int a[MAXN][MAXN], cnt[MAXN][MAXN], n, m, p, levo[MAXN][MAXN], desno[MAXN][MAXN];
ll dp[MAXN][MAXN], ress;

/*bool mozeLevo(int i, int j, int k)
{
    if (j==k) return a[i][j];
    if (a[i][k]==0) return false;
    if (cnt[i][k]>j-1) return false;

    int l=1, r=j;
    int pos=-1;
    while (l<=r)
    {
        int mid=l+(r-l)/2;
        if (cnt[i][k]-cnt[i][mid]<j-mid)
        {
            pos=mid; l=mid+1;
        }
        else
            r=mid-1;
    }

    if (pos==-1) return false;
    if (cnt[i][k]-cnt[i][pos]<=p) return true;
    else return false;
}
bool mozeDesno(int i, int j, int k)
{
    if (a[i][k]==0) return false;
    if (cnt[i][m]-cnt[i][k-1]>m-j) return false;

    int l=j, r=m;
    int pos=-1;
    while (l<=r)
    {
        int mid=l+(r-l)/2;
        if ((cnt[i][m]-cnt[i][k-1])-(cnt[i][m]-cnt[i][mid-1])<mid-j)
        {
            pos=mid; r=mid-1;
        }
        else
        {
            l=mid+1;
        }
    }
    if (pos==-1) return false;
    if (cnt[i][pos-1]-cnt[i][k]<=p) return true;
    else return false;
}*/

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin>>n>>m>>p;

    for (int i=1; i<=n; i++) { string s; cin>>s; for (int j=1; j<=m; j++) a[i][j]=(s[j-1]-'0'); }

    for (int j=1; j<=m; j++) dp[n+1][j]=1;

    for (int i=1; i<=n; i++) for (int j=1; j<=m; j++) { cnt[i][j]=cnt[i][j-1]+a[i][j]; /*cout<<i<<" "<<j<<" "<<cnt[i][j]<<endl;*/ }

    for (int i=1; i<=n; i++)
    {
        int k=0;
        for (int j=1; j<=m; j++)
        {
            if (a[i][j]==1) {  /*cout<<"retarde "<<i<<" "<<j<<endl;*/ levo[i][j]=m+1; }
            else if (cnt[i][j]<=p) levo[i][j]=cnt[i][j]+1;
            else
            {
                //cout<<i<<" "<<j<<" "<<k<<" "<<cnt[i][j]-cnt[i][k]<<" "<<p<<endl;
                while (k<j && (cnt[i][j]-cnt[i][k])>p) k++;
                //cout<<"a sad k "<<k<<endl;
                levo[i][j]=k+(cnt[i][j]-cnt[i][k])+1;
            }
        }

        k=m+1;
        for (int j=m; j>=1; j--)
        {
            if (a[i][j]==1) desno[i][j]=0;
            else if ((cnt[i][m]-cnt[i][j-1])<=p) desno[i][j]=m-(cnt[i][m]-cnt[i][j-1]);
            else
            {
                while (k>j && (cnt[i][k-1]-cnt[i][j-1])>p) k--;
                desno[i][j]=k-(cnt[i][k-1]-cnt[i][j-1])-1;
            }
        }
    }

    /*for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=m; j++) cout<<levo[i][j]<<" ld "<<desno[i][j]<<"  ";
        cout<<endl;
    }*/

    for (int i=n; i>=2; i--)
    {
        int k=1;
        ll kolko=0;
        for (int j=1; j<=m; j++)
        {
            while (k<j) k++;
            while (k<=m && (levo[i][k]<=j || levo[i][k]==m+1))
            {
                if (!a[i][k]) kolko=add(kolko, dp[i+1][k]);
                k++;
            }
            //cout<<i<<" "<<j<<" ide do "<<k<<endl;
            //cout<<kolko<<" dodajem sadesna na "<<i<<" "<<j<<endl;
            dp[i][j]=add(dp[i][j], kolko);
            if (!a[i][j]) kolko=sub(kolko, dp[i+1][j]);
        }

        k=m;
        kolko=0;
        for (int j=m; j>=1; j--)
        {
            while (k>j) k--;
            while (k>0 && (desno[i][k]>=j || desno[i][k]==0))
            {
                if (!a[i][k]) kolko=add(kolko, dp[i+1][k]);
                k--;
            }
            dp[i][j]=add(dp[i][j], kolko);
            //cout<<kolko<<" dodajem saleva na "<<i<<" "<<j<<endl;
            if (!a[i][j]) kolko=sub(kolko, dp[i+1][j]);
        }
        for (int j=1; j<=m; j++) if (!a[i][j]) dp[i][j]=sub(dp[i][j], dp[i+1][j]);

        //for (int j=1; j<=m; j++) cout<<dp[i][j]<<" ";
        //cout<<endl;
    }

    for (int j=1; j<=m; j++) if (!a[1][j]) ress=add(ress, dp[2][j]);
    cout<<ress;
}

/*
3 9 3
010001100
101011010
011101110
*/