#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 2e5+45;

int n;
set <int> g[N];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 1; i < n; i++){
        int u,v;
        cin >> u >> v;
        g[u].insert(v);
        g[v].insert(u);
    }

    int mini = N,v1 = 0,v2 = 0,cent = 0;
    for(int i = 1; i <= n; i++){
        for(int j = i+1; j <= n; j++){
            if(g[i].find(j) != g[i].end()) continue;
            g[i].insert(j);
            g[j].insert(i);

            for(int c = 1; c <= n; c++){
                queue <pair<int,int>> q;
                q.push({0,c});
                vector <int> visited(n+1,0);
                visited[c] = 1;
                int mxdist = 0;
                while(!q.empty()){
                    auto tp = q.front();
                    q.pop();
                    int dst = tp.first;
                    mxdist = max(mxdist,dst);
                    int u = tp.second;
                    for(auto f : g[u]){
                        if(!visited[f]){
                            visited[f] = 1;
                            q.push({dst+1,f});
                        }
                    }
                }

                if(mxdist < mini){
                    mini = mxdist;
                    v1 = i;
                    v2 = j;
                    cent = c;
                }
            }
            g[i].erase(j);
            g[j].erase(i);
        }
    }

    cout << v1 << " " << v2 << endl;
    cout << cent << endl;
}