#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define INF (long long)1e18
#define MOD (long long)(1e9 + 7)
#define sz(x) ((int)x.size())
#define X real()
#define Y imag()
#define F first
#define S second
#define EPS 1e-9
#define PI 3.141592
#define cross(a, b) (conj(a) * b).Y
#define MAN(a, b) norm(a - b)
#define EUC(a, b) abs(a - b)
#define PB push_back
#define REP(i, a, b) for (int i = a; i < b; i++)
#define RREP(i, a, b) for (int i = a; i >= b; i--)
#define heap priority_queue
#define endl '\n'
const double PI2 = acos(0.0);
typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef unsigned short us;
typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

int n, m, k;
char tmpC;
vector<vector<bool>> mat;

void solve(){
    cin >> n >> m >> k;
    mat.resize(n, vector<bool>(m, 0));

    REP(i, 0, n) REP(j, 0, m) {
        cin >> tmpC;
        if (tmpC == '0') mat[i][j] = 0;
        else mat[i][j] = 1;
    }

    vector<int> ans(m, 1), tmp(m);
    int seg = 0, tJ;
    RREP(i, n - 1, 1) {
        REP(j, 0, m) tmp[j] = 0;
        // guranje desno
        REP(j, 0, m) {
            if (mat[i][j]) continue;
            tJ = j;
            seg = 0;
            do{
                tmp[tJ] += ans[j];
                while (tJ + seg + 1 < m && mat[i][tJ + seg + 1]) ++seg;
                ++tJ;
                //cout << tJ << " " << seg << " " << k << endl;
            }while(tJ + seg < m && seg <= k);
        }
        // guranje levo
        RREP(j, m - 1, 0) {
            if (mat[i][j]) continue;
            tJ = j;
            seg = 0;
            do{
                tmp[tJ] += ans[j];
                while (tJ - seg - 1 >= 0 && mat[i][tJ - seg - 1]) ++seg;
                --tJ;
                //cout << i << " " << tJ << " " << seg << " " << k << endl;
            }while(tJ - seg >= 0 && seg <= k);
        }

        REP(j, 0, m) if (mat[i][j] == 0) tmp[j] -= ans[j];

        ans = tmp;
    }

    ll x = 0;
    REP(i, 0, m) if (mat[0][i] == 0) x += ans[i];
    cout << x << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;//cin >> t;
    REP(i, 0, t) solve();

    return 0;
}