using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Diagnostics.SymbolStore;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Net.WebSockets;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Schema;
using System.Numerics;
//using System.Data;
//using System.Drawing;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            var s = Console.ReadLine().Split();
            int n = int.Parse(s[0]);
            int m = int.Parse(s[1]);
            int k = int.Parse(s[2]);
            int[,] mat = new int[n, m];
            int br = 0;
            for(int i=0;i<n;i++)
            {
                string s1 = Console.ReadLine();
                for(int j=0;j<m;j++)
                {
                    mat[i,j]=s1[j]-48;
                    br += mat[i, j];
                }
            }
            if(br==0 || k==0)
            {
                long[,] dp = new long[n, m];
                for (int j = 0; j < m; j++)
                {
                    if (mat[n - 1, j] == 0)
                    {
                        dp[n - 1, j] = 1;
                    }
                }
                for (int i = n - 1; i > 0; i--)
                {
                    for (int j = 0; j < m - 1; j++)
                    {
                        if (mat[i, j] == 0 && mat[i, j + 1] == 0)
                        {
                            dp[i, j + 1] += dp[i, j];
                        }
                    }
                    long[] nz = new long[m];
                    for (int j = 0; j < m; j++)
                    {
                        if (mat[i, j] == 0)
                        {
                            if (i + 1 < n)
                                nz[j] = dp[i + 1, j];
                            else nz[j] = 1;
                        }
                    }
                    for (int j = m - 1; j > 0; j--)
                    {
                        if (mat[i, j] == 0 && mat[i, j - 1] == 0)
                        {
                            nz[j - 1] += nz[j];
                        }
                    }
                    for (int j = 0; j < m; j++)
                    {
                        dp[i, j] += nz[j];
                        if (mat[i, j] == 0)
                        {
                            if (i + 1 < n)
                                dp[i, j] -= dp[i + 1, j];
                            else dp[i, j]--;
                        }
                        if (mat[i - 1, j] == 0)
                            dp[i - 1, j] += dp[i, j];
                    }
                }
                const int mod = (int)1e9 + 7;
                long ans = 0;
                for (int j = 0; j < m; j++)
                {
                    ans = (ans + dp[0, j]) % mod;
                }
                Console.WriteLine(ans);
            }
            else Console.WriteLine(0);
        }
    }
}