#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define endl "\n"

using namespace std;

const ll mod = 1e9+7;

int h,w,k;

ll add(ll a, ll b) {
    return ((a%mod)+(b%mod)) % mod;
}

void solve()
{
    cin >> h >> w >> k;

    vector<vector<int>> a(h, vector<int>(w));
    vector<vector<pair<int,int>>> range(h, vector<pair<int,int>>(w, {-1, -1}));

    for(int i=0; i<h; i++) {
        for(int j=0; j<w; j++) {
            char c; cin >> c;
            a[i][j] = c-'0';
        }
    }

    //////

    for(int i=0; i<h; i++) {

        queue<ll> jedan;

        for(int j=0; j<w; j++) {
            if(a[i][j] == 0)
                continue;

            jedan.push(j);
            if(jedan.size()>k+1)
                jedan.pop();

            if(jedan.size()==k+1) {

                if(jedan.front()>0) {
                    if(a[i][jedan.front()-1] == 0) {
                        ll start = jedan.back()-jedan.front()-k;
                        range[i][jedan.front()-1].second = jedan.front()-1+start;

                        for(int rr=jedan.front()-2; rr>=0; rr--) {
                            if(a[i][rr] == 1)
                                break;

                            start++;
                            range[i][rr].second = rr+start;
                        }
                    }
                }

                if(jedan.back()<w-1) {
                    if(a[i][jedan.back()+1] == 0) {
                        ll start = jedan.back()-jedan.front()-k;
                        range[i][jedan.back()+1].first = jedan.back()+1-start;

                        for(int rr=jedan.back()+2; rr<w; rr++) {
                            if(a[i][rr] == 1)
                                break;

                            start++;
                            range[i][rr].first = rr-start;
                        }
                    }
                }


            }

        }


        int nule = 0;
        for(int j=0; j<w; j++) {
            if(a[i][j] == 1)
                continue;

            if(range[i][j].first != -1)
                break;

            range[i][j].first = j-nule;
            nule++;
        }

        nule = 0;
        for(int j=w-1; j>=0; j--) {
            if(a[i][j] == 1)
                continue;

            if(range[i][j].second != -1)
                break;

            range[i][j].second = j+nule;
            nule++;
        }

    }

    ///
//    cout << endl;
//    for(int i=0; i<h; i++) {
//        for(int j=0; j<w; j++)
//            cout << "[" << range[i][j].first << "," << range[i][j].second << "] ";
//        cout << endl;
//    }
//    return;

    ll dp[h][w];
    ll dppf[h][w];

    for(int j=0; j<w; j++)
        dp[0][j] = a[0][j] ? 0 : 1;

    for(int i=1; i<h; i++) {
        for(int j=0; j<w; j++) {
            if(!j)
                dppf[i-1][j] = dp[i-1][j];
            else
                dppf[i-1][j] = dp[i-1][j] + dppf[i-1][j-1];
        }

        for(int j=0; j<w; j++) {
            if(a[i][j] == 0) {
                int L = range[i][j].first;
                int R = range[i][j].second;

                if(!L)
                    dp[i][j] = dppf[i-1][R] % mod;
                else
                    dp[i][j] = (dppf[i-1][R] - dppf[i-1][L-1]) % mod;
            }
            else
                dp[i][j] = 0;
        }
    }

//    cout << endl << endl;
//
//    for(int i=0; i<h; i++) {
//        for(int j=0; j<w; j++)
//            cout << dp[i][j] << " ";
//        cout << endl;
//    }
//
//    cout << endl;

    ll ans = 0;
    for(int j=0; j<w; j++) {
        if(!a[h-1][j])
            ans += dp[h-1][j];
    }

    cout << ans%mod << endl;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int t=1; //cin >> t;
    while(t--)
        solve();

    return 0;
}