#include <bits/stdc++.h>
#define MOD 1000000007

using namespace std;

long long n,m,k;
long long mat[2005][2005];
long long brnacina[2005][2005];
bool pos[2005][2005];
long long dp[2005][2005];

long long f(int x,int y)
{
    if(x<=0 || x>n || y<=0 || y>m)
        return 0;
    if(mat[x][y]==1)
        return 0;
    if(pos[x][y])
        return 0;
    if(x==1)
        return 1;
    if(dp[x][y]!=-1)
        return dp[x][y];
    pos[x][y]=true;
    dp[x][y]=f(x-1,y)%MOD + f(x,y-1)%MOD + f(x,y-1)%MOD;
    dp[x][y]%=MOD;
    pos[x][y]=false;
    return dp[x][y];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m>>k;
    for(long long i=1;i<=n;i++)
    {
        string s;
        cin>>s;
        for(long long j=1;j<=m;j++)
        {
            if(s[j-1]=='0')
                mat[i][j]=0;
            else
                mat[i][j]=1;
        }
    }
    bool prov=true;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(mat[i][j]!=0)
                prov=false;
        }
    }
    if(prov)
    {
        long long res=1;
        for(int i=1;i<=n;i++)
        {
            res*=m%MOD;
            res%=MOD;
        }
        cout<<res;
        return 0;
    }
    if(k==0)
    {
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=m;j++)
            {
                pos[i][j]=false;
                dp[i][j]=-1;
            }
        }
        int res=0;
        for(int i=1;i<=m;i++)
            res+=f(n,i);
        cout<<res;
        return 0;
    }
    for(long long i=1;i<=m;i++)
    {
        if(mat[n][i]==0)
            brnacina[n][i]=1;
        else
            brnacina[n][i]=0;
    }
    for(long long tren=1;tren<=m;tren++)
    {
        if(mat[n][tren]==1)
            continue;
        long long brljudi=0,brmesta=0;
        long long i=tren;
        while(k>=brljudi && tren+brljudi+brmesta<m)
        {
            i++;
            if(brljudi+mat[n][i]>k)
                break;
            brljudi+=mat[n][i];
            brmesta+=1-mat[n][i];
        }
        for(long long i=1;i<=brmesta;i++)
        {
            brnacina[n][tren+i]++;
        }

        brljudi=0;
        brmesta=0;
        i=tren;
        while(i>=2 && k>=brljudi)
        {
            i--;
            if(brljudi+mat[n][i]>k)
                break;
            brljudi+=mat[n][i];
            brmesta+=1-mat[n][i];
        }
        for(i=1;i<=brmesta;i++)
        {
            brnacina[n][tren-i]++;
        }
    }
    for(long long d=n-1;d>0;d--)
    {
        for(long long i=1;i<=m;i++)
        {
            if(mat[d][i]==0)
                brnacina[d][i]=brnacina[d+1][i];
            else
                brnacina[d][i]=0;
        }
        long long a[2005];
        for(long long i=1;i<=m;i++)
            a[i]=brnacina[d][i];
        for(long long tren=1;tren<=m;tren++)
        {
            if(brnacina[d][tren]==0)
                continue;
            long long brljudi=0,brmesta=0;
            long long i=tren;
            while(k>=brljudi && tren+brljudi+brmesta<m)
            {
                i++;
                if(brljudi+mat[d][i]>k)
                    break;
                brljudi+=mat[d][i];
                brmesta+=1-mat[d][i];
            }
            for(long long i=1;i<=brmesta;i++)
            {
                brnacina[d][tren+i]+=a[tren];
            }
            brljudi=0;
            brmesta=0;
            i=tren;
            while(i>=2 && k>=brljudi)
            {
                i--;
                if(brljudi+mat[d][i]>k)
                    break;
                brljudi+=mat[d][i];
                brmesta+=1-mat[d][i];
            }
            for(i=1;i<=brmesta;i++)
            {
                brnacina[d][tren-i]+=a[tren];
            }
        }
    }
    for(long long i=1;i<=m;i++)
    {
        if(mat[1][i]==0)
            brnacina[1][i]=brnacina[2][i];
        else
            brnacina[1][i]=0;
    }
    long long res=0;
    for(int i=1;i<=m;i++)
    {
        res+=brnacina[1][i];
    }
    cout<<res%MOD;
    return 0;
}