#include <bits/stdc++.h>
using namespace std;

const int N = 200005;

vector<int> graph[N];

int bDist = 0;
vector<int> bdNode;

void getFarthest(int v, int p, int d){
    if(d >= bDist){
        if(d > bDist)
            bdNode.clear();
        bDist = d;
        bdNode.push_back(v);
    }
    for(auto u : graph[v]){
        if(u == p)
            continue;
        getFarthest(u, v, d + 1);
    }
}

int mid = -1;

bool getMid(int v, int goal, int d, int need, int p){
    if(v == goal)
        return true;

    for(auto u : graph[v]){
        if(u == p)
            continue;
        bool otw = getMid(u, goal, d + 1, need, v);
        if(otw && d == need){
            mid = v;
        }
    }
}

int depth[N];

void getDepth(int v, int p, int d){
    depth[v] = d;
    for(auto u : graph[v]){
        if(u == p)
            continue;
        getDepth(u, v, d + 1);
    }
}

int main()
{
    int n;
    cin >> n;
    for(int i = 0; i < n - 1; ++i){
        int x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    bdNode.clear();
    bDist = 0;
    getFarthest(1, -1, 0);

    int x = bdNode[0];
    bDist = 0;
    bdNode.clear();
    getFarthest(x, -1, 0);
    int y = bdNode[0];

    mid = -1;
    getMid(x, y, 0, bDist / 2, -1);

    int root = mid;
    getDepth(root, -1, 0);

    vector<int> deepest;
    int mxD = 0;
    for(int i = 1; i <= n; ++i){
        if(depth[i] >= mxD){
            if(depth[i] > mxD){
                deepest.clear();
            }
            mxD = depth[i];
            deepest.push_back(i);
        }
    }

    cout << "1 2\n";
    cout << depth[deepest[0]] * 2 << "\n";
    return 0;
}