#include <bits/stdc++.h>
using namespace std;

const int N = 200005;

vector<int> graph[N];

int bDist = 0;
vector<int> bdNode;
int n;

void getFarthest(int v, int p, int d){
    if(d >= bDist){
        if(d > bDist)
            bdNode.clear();
        bDist = d;
        bdNode.push_back(v);
    }
    for(auto u : graph[v]){
        if(u == p)
            continue;
        getFarthest(u, v, d + 1);
    }
}

int mid = -1;
vector<int> path;

bool getMid(int v, int goal, int d, int need, int p){
    if(v == goal){
        path.push_back(v);
        return true;
    }

    bool fnd = false;
    for(auto u : graph[v]){
        if(u == p)
            continue;
        bool otw = getMid(u, goal, d + 1, need, v);
        fnd |= otw;
        if(otw && d == need){
            mid = v;
        }
    }

    if(fnd){
        path.push_back(v);
    }
    return fnd;
}

bool visited[N];

void gf(int v, int d){
    if(visited[v])
        return;
    if(d >= bDist){
        if(d > bDist)
            bdNode.clear();
        bDist = d;
        bdNode.push_back(v);
    }
    visited[v] = true;
    for(auto u : graph[v]){
        gf(u, d + 1);
    }
}

struct Sol{
    int x, y, d;
};

void solve(){
    int psz = path.size();

    Sol sol;
    sol.d = INT_MAX;

    for(int i = 0; i < psz; ++i){
        for(int j = i + 2; j < psz; ++j){
            int x = path[i];
            int y = path[j];
            graph[x].push_back(y);

            for(int z = 1; z <= n; ++z){
                visited[z] = false;
            }

            bdNode.clear();
            bDist = 0;
            gf(1, 0);
            int st = bdNode[0];

            for(int z = 1; z <= n; ++z){
                visited[z] = false;
            }
            bdNode.clear();
            bDist = 0;
            gf(st, 0);

            if(sol.d > ceil(bDist / 2.0)){
                sol.d = ceil(bDist / 2.0);
                sol.x = x;
                sol.y = y;
            }

            graph[x].pop_back();
        }
    }

    cout << sol.x << " " << sol.y << "\n";
    cout << sol.d << "\n";
}

int main()
{

    cin >> n;
    for(int i = 0; i < n - 1; ++i){
        int x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    bdNode.clear();
    bDist = 0;
    getFarthest(1, -1, 0);

    int xxx = bdNode[0];
    bDist = 0;
    bdNode.clear();
    getFarthest(xxx, -1, 0);
    int yyy = bdNode[0];

    mid = -1;
    getMid(xxx, yyy, 0, bDist / 2, -1);

    solve();

    return 0;
}

/*
10
1 2
2 3
2 4
2 5
1 6
6 7
7 8
8 9
7 10
*/