#include <bits/stdc++.h>
using namespace std;

const int N = 200005;

vector<int> graph[N];

int bDist = 0;
vector<int> bdNode;
int n;

bool visited[N];

void gf(int v, int d){
    if(visited[v])
        return;
    if(d >= bDist){
        if(d > bDist)
            bdNode.clear();
        bDist = d;
        bdNode.push_back(v);
    }
    visited[v] = true;
    for(auto u : graph[v]){
        gf(u, d + 1);
    }
}

struct Sol{
    int x, y, d;
};

void solve(){

    Sol sol;
    sol.d = INT_MAX;

    for(int i = 1; i <= n; ++i){
        for(int j = i + 1; j <= n; ++j){
            bool flag = false;
            for(auto x : graph[i]){
                if(x == j){
                    flag = true;
                    break;
                }
            }
            if(flag){
                continue;
            }


            graph[i].push_back(j);

            for(int z = 1; z <= n; ++z){
                visited[z] = false;
            }

            bdNode.clear();
            bDist = 0;
            gf(1, 0);
            int st = bdNode[0];

            for(int z = 1; z <= n; ++z){
                visited[z] = false;
            }
            bdNode.clear();
            bDist = 0;
            gf(st, 0);

            if(sol.d > ceil(bDist / 2.0)){
                sol.d = ceil(bDist / 2.0);
                sol.x = i;
                sol.y = j;
            }

            graph[i].pop_back();
        }
    }

    cout << sol.x << " " << sol.y << "\n";
    cout << sol.d << "\n";
}

int main()
{

    cin >> n;
    for(int i = 0; i < n - 1; ++i){
        int x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    solve();

    return 0;
}

/*
10
1 2
2 3
2 4
2 5
1 6
6 7
7 8
8 9
7 10
*/