#include <bits/stdc++.h>
using namespace std;

const long long N = 200005;

vector<long long> graph[N];

long long bDist = 0;
vector<long long> bdNode;
long long n;

bool visited[N];

void gf(long long v, long long d){
    if(visited[v])
        return;

    if(d > bDist){
        bDist = d;
        bdNode.clear();
        bdNode.push_back(v);
    }else if(d == bDist){
        bdNode.push_back(v);
    }

    visited[v] = true;
    for(auto u : graph[v]){
        gf(u, d + 1);
    }
}

struct Sol{
    long long x, y, d;
};

void solve(){

    Sol sol;
    sol.d = LLONG_MAX;

    for(long long i = 1; i <= n; ++i){
        for(long long j = i + 1; j <= n; ++j){
            bool flag = false;
            for(auto x : graph[i]){
                if(x == j){
                    flag = true;
                    break;
                }
            }
            if(flag){
                continue;
            }

            graph[i].push_back(j);

            for(long long z = 1; z <= n; ++z){
                visited[z] = false;
            }

            bdNode.clear();
            bDist = 0;
            gf(1, 0);
            long long st = bdNode[0];

            for(long long z = 1; z <= n; ++z){
                visited[z] = false;
            }
            bdNode.clear();
            bDist = 0;
            gf(st, 0);

            long long mxDist = ceil(bDist / 2.0);
            if(mxDist < sol.d){
                sol.d = mxDist;
                sol.x = i;
                sol.y = j;
            }

            graph[i].pop_back();
        }
    }

    cout << sol.x << " " << sol.y << "\n";
    cout << sol.d << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;
    for(long long i = 0; i < n - 1; ++i){
        long long x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        graph[y].push_back(x);
    }

    solve();

    return 0;
}

/*
10
1 2
2 3
2 4
2 5
1 6
6 7
7 8
8 9
7 10
*/