#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define sp ' '
#define en '\n'
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
using namespace std;
const int N = 2e3 + 2;
const int M = 2e5 + 2;
const int mod = 1e9 + 7;
vector<int> g[M];
int dist[N][N];
void dfs(int s, int e, int r) {
    for (auto u : g[s]) {
        if (u == e) continue;
        dist[r][u] = dist[r][s] + 1;
        dfs(u, s, r);
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, u, v;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int s1 = 1;
    for (int i = 1; i <= n; i++) {
        s1 &= (g[i].size() <= 2);
    }
    if (s1) {
        int root = 1;
        for (int i = 1; i <= n; i++) {
            if (g[i].size() < g[root].size()) root = i;
        }
        vector<int> v;
        function<void(int, int)> Dfs = [&] (int s, int e) {
            v.push_back(s);
            for (int u : g[s]) {
                if (u == e) continue;
                Dfs(u, s);
            }
        };
        Dfs(root, 0);
        int A, B, C, D;
        A = B = C = -1;
        D = n;
        for (int i = 0; i < n; i++) {
            int p = i - 1;
            int q = n - 1 - i;
            if (p < q) {
                int pos = i + q - q / 3;
                int tmp = max(p, n - pos);
                if (tmp < D) {
                    A = C = v[i];
                    B = v[pos];
                    D = tmp;
                }
            }
            else {
                int pos = i - p + p / 3;
                int tmp = max(q, pos + 1);
                if (tmp < D) {
                    A = C = v[i];
                    B = v[pos];
                    D = tmp;
                }
            }
        }
        cout << A << sp << B << en;
        cout << C << en;
        return 0;
    }
    for (int i = 1; i <= n; i++) {
        dist[i][i] = 0;
        dfs(i, i, i);
    }
    int A, B, C, D;
    A = B = C = 1;
    D = n;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            int ans = 0;
            for (int k = 1; k <= n; k++) {
                smax(ans, min(dist[i][k], dist[j][k] + 1));
            }
            if (ans <= D) {
                A = C = i;
                B = j;
                D = ans;
            }
        }
    }
    cout << A << sp << B << en;
    cout << C << en;
    return 0;

}