#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> u(n);
  vector<int> v(n);
  vector<vector<int>> g(n);
  for (int i = 1; i < n; i++) {
    cin >> u[i] >> v[i];
    --u[i]; --v[i];
    g[u[i]].push_back(v[i]);
    g[v[i]].push_back(u[i]);
  }
  vector<int> sz(n);
  function<void(int, int)> Dfs = [&](int u, int p) {
    sz[u] = 1;
    for (int v : g[u]) {
      if (v == p) {
        continue;
      }
      Dfs(v, u);
      sz[u] += sz[v];
    }
  };
  Dfs(0, 0);
  int cen = -1;
  vector<int> vec;
  function<void(int, int)> Dfs1 = [&](int u, int p) {
    bool ok = true;
    for (int v : g[u]) {
      ok &= (sz[v] < n / 2);
    }
    if (ok) {
      cen = u;
      return;
    }
    bool cand = true;
    for (int v : g[u]) {
      cand &= (sz[v] <= n / 2);
    }
    if (cand) {
      vec.push_back(u);
    }
    for (int v : g[u]) {
      if (v == p) {
        continue;
      }
      sz[u] -= sz[v];
      sz[v] += sz[u];
      Dfs1(v, u);
      sz[v] -= sz[u];
      sz[u] += sz[v];
      if (cen != -1) {
        return;
      }
    }
  };
  Dfs1(0, 0);
  if (cen == -1) {
    assert(!vec.empty());
    cen = vec[0];
  }
  auto Calc = [&](int x, int y) {
    vector<vector<int>> ng(n);
    for (int i = 1; i < n; i++) {
       ng[u[i]].push_back(v[i]);
       ng[v[i]].push_back(u[i]);
    }
    ng[x].push_back(y);
    ng[y].push_back(x);
    vector<int> dist(n, -1);
    vector<int> que(1, cen);
    dist[cen] = 0;
    for (int b = 0; b < que.size(); b++) {
      int p = que[b];
      for (int q : ng[p]) {
        if (dist[q] == -1) {
          dist[q] = dist[p] + 1;
          que.push_back(q);
        }
      }
    }
    int ret = 0;
    for (int i = 0; i < n; i++) {
      ret += dist[i];
    }
    return ret;
  };
  int tot = 1e9, x = -1, y = -1;
  for (int i = 0; i < n; i++) {
    for (int j = i + 1; j < n; j++) {
      int ft = Calc(i, j);
      if (ft < tot) {
        ft = tot;
        x = i;
        y = j;
      }
    }
  }
  cout << x + 1 << " " << y + 1 << '\n';
  cout << cen + 1 << '\n';
  return 0;
}