#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> u(n);
  vector<int> v(n);
  vector<vector<int>> g(n);
  map<pair<int, int>, bool> have;
  for (int i = 1; i < n; i++) {
    cin >> u[i] >> v[i];
    --u[i]; --v[i];
    have[{u[i], v[i]}] = true;
    have[{v[i], u[i]}] = true;
    g[u[i]].push_back(v[i]);
    g[v[i]].push_back(u[i]);
  }
  int du = -1, dv = -1;
  {
    auto Bfs = [&](int u) {
      vector<int> dist(n, -1);
      dist[u] = 0;
      vector<int> que;
      que.push_back(u);
      for (int v : g[u]) {
        if (dist[v] == -1) {
          dist[v] = dist[u] + 1;
          que.push_back(v);
        }
      }
      return max_element(dist.begin(), dist.end()) - dist.begin();
    };
    du = Bfs(0);
    dv = Bfs(du);
  }
  int cen = -1;
  /*if (cen == -1) {
    assert(!vec.empty());
    cen = vec[0];
  }*/
  vector<int> par(n), dep(n);
  function<void(int, int)> Dfs = [&](int u, int p) {
    par[u] = p;
    dep[u] = dep[p] + 1;
    for (int v : g[u]) {
      if (v == p) {
        continue;
      }
      Dfs(v, u);
    }
  };
  Dfs(0, 0);
  vector<int> path;
  while (du != dv) {
    if (dep[du] > dep[dv]) {
      path.push_back(du);
      du = par[du];
    } else {
      path.push_back(dv);
      dv = par[dv];
    }
  }
  if (path.empty() || path.back() != du) {
    path.push_back(du);
  }
  auto Calc = [&](int x, int y) {
    vector<vector<int>> ng(n);
    for (int i = 1; i < n; i++) {
       ng[u[i]].push_back(v[i]);
       ng[v[i]].push_back(u[i]);
    }
    ng[x].push_back(y);
    ng[y].push_back(x);
    vector<int> dist(n, -1);
    vector<int> que(1, cen);
    dist[cen] = 0;
    for (int b = 0; b < que.size(); b++) {
      int p = que[b];
      for (int q : ng[p]) {
        if (dist[q] == -1) {
          dist[q] = dist[p] + 1;
          que.push_back(q);
        }
      }
    }
    int ret = 0;
    for (int i = 0; i < n; i++) {
      ret = max(ret, dist[i]);
    }
    return ret;
  };
  int tot = 1e9, x = -1, y = -1, cc = -1;
  int sz = path.size();
  vector<int> cands;
  cands.push_back(path[sz / 2]);
  if (sz % 2 == 0) {
    cands.push_back(path[(sz + 1) / 2]);
  }
  for (int c = max(0, (int) path.size() - 3); c < path.size(); c++) {
    cen = path[c];
    for (int i = 0; i < n; i++) {
      if (i < 0 || i >= n) {
        continue;
      }
      for (int j = i + 1; j < n; j++) {
        if (have[{i, j}]) {
          continue;
        }
        int ft = Calc(i, j);
        if (ft < tot) {
          tot = ft;
          x = i;
          y = j;
          cc = cen;
        }
      }
    }
  }
  cout << x + 1 << " " << y + 1 << '\n';
  cout << cc + 1 << '\n';
  return 0;
}