#include <bits/stdc++.h>
using namespace std;

#define ll long long
const int N = 200001;
int a[N], b[N];
vector<int> graph[N];
int maxx = 0;
int par[N], dp[N];
int maxdp[N];
int v2 = 0, v1 = 0;
int br1 = 0;

void dfs(int u, int poc) {
    if (u != poc)
        dp[u] = dp[par[u]] + 1;
    if (dp[u] > maxx) {
        maxx = dp[u];
        v2 = u;
    }
    for (auto i = graph[u].begin(); i != graph[u].end(); i++) {
        if (*i != par[u]) {
            par[*i] = u;
            dfs(*i, poc);
        }
    }
}

void dfs1(int u, pair<int, int> &grana) {
    maxdp[u] = 0;
    if (dp[u] == maxx) {
        maxdp[u]++;
    }
    for (auto i = graph[u].begin(); i != graph[u].end(); i++) {
        if (*i != par[u]) {
            dfs1(*i, grana);
            maxdp[u] += maxdp[*i];
        }
    }
    if (dp[u] == 2 && maxdp[u]) {
        grana.first = u;
        br1++;
    }
}

int nadji(int u, pair<int, int> &grana) {
    grana.second = u;
    maxx = 0;
    dp[u] = 0;
    par[u] = u;
    dfs(u, u);
    dfs1(u, grana);
    if (br1 <= 1)
        return maxx / 2;
    return maxx / 2 + 1;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    int u1, u2;
    dfs(1, 1);
    v1 = v2;
    par[v1] = v1;
    dp[v1] = 0;
    dfs(v1, v1);
    int x = maxx;
    int euro1 = v2, euro2 = v2;
    int g1, g2;
    while (x > maxx / 2) {
        euro2 = par[euro2];
        x--;
    }
    if (maxx % 2 == 0) {
        int res1 = v2, res2 = par[par[v2]];
        cout << res1 << " " << res2 << endl;
        cout << euro2 << endl;
        return;
    }
    x = maxx;
    while (x > maxx / 2 + 1) {
        euro1 = par[euro1];
        x--;
    }
    pair<int, int> grana1, grana2;
    int r1 = nadji(euro1, grana1), r2 = nadji(euro2, grana2);
    if (r1 < r2) {
        cout << grana1.first << " " << grana1.second << endl;
        cout << euro1 << endl;
        return;
    }
    cout << grana2.first << " " << grana2.second << endl;
    cout << euro2 << endl;
}

int main()
{
    ios_base::sync_with_stdio();
    cin.tie(NULL);
    solve();
    return 0;
}

/*11
1 2
2 3
3 4
4 5
1 8
8 9
9 10
1 11
11 6
6 7
*/