#include <bits/stdc++.h>
using namespace std;

#define ll long long
const int N = 200005;
int a[N], b[N];
set<int> graph[N];
int maxx = 0;
int par[N], dp[N];
int maxdp[N];
int v2 = 0, v1 = 0;
int br1 = 0;
int n;

void dfs(int u, int poc, pair<int, int> &grana) {
    if (u != poc)
        dp[u] = dp[par[u]] + 1;
    if (dp[u] > maxx) {
        maxx = dp[u];
        v2 = u;
    }
    if (graph[u].size() > 1) {
        auto it = graph[u].begin();
        grana.first = *it;
        it++;
        grana.second = *it;
    }
    for (auto i = graph[u].begin(); i != graph[u].end(); i++) {
        if (*i != par[u]) {
            par[*i] = u;
            dfs(*i, poc, grana);
        }
    }
}

void dfs1(int u) {
    if (dp[u] == maxx) {
        maxdp[u]++;
    }
    for (auto i = graph[u].begin(); i != graph[u].end(); i++) {
        if (*i != par[u]) {
            dfs1(*i);
            maxdp[u] += maxdp[*i];
        }
    }
}

int dfs2(int u, int br) {
    if (br == ceil(maxx / 2.0))
        return u;
    for (auto i = graph[u].begin(); i != graph[u].end(); i++) {
        if (*i != par[u]) {
            if (maxdp[*i] != maxdp[u])
                continue;
            return dfs2(*i, br + 1);
        }
    }
    return u;
}

void refresh() {
    for (int i = 1; i <= n; i++) {
        maxdp[i] = 0;
        dp[i] = 0;
        par[i] = 0;
    }
    maxx = 0;
}

/*int nadji(int u, pair<int, int> &grana) {
    refresh();
    grana.second = u;
    dp[u] = 0;
    par[u] = u;
    dfs(u, u);
    dfs1(u, grana);
    if (br1 <= 1)
        return maxx / 2;
    return maxx / 2 + 1;
}*/

void solve() {
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        graph[u].insert(v);
        graph[v].insert(u);
    }
    pair<int, int>grana;
    dfs(1, 1, grana);
    int resenje = 1;
    refresh();
    int najbolje = n;
    for (int i = 1; i <= n; i++) {
        refresh();
        pair<int, int> grana1;
        dfs(i, i, grana1);
        dfs1(i);
        int x = dfs2(i, 0);
        if (maxx < najbolje) {
            if (dp[x] <= 1) {
                najbolje = maxx;
                grana = grana1;
                resenje = i;
                continue;
            }
        }
        if (dp[x] <= 1)
            continue;
        graph[x].erase(par[x]);
        graph[par[x]].erase(x);
        graph[x].insert(i);
        graph[i].insert(x);
        refresh();
        dfs(i, i, grana1);
        if (najbolje > maxx) {
            grana = {x, i};
            resenje = i;
            najbolje = maxx;
        }
        graph[x].insert(par[x]);
        graph[par[x]].insert(x);
        graph[x].erase(i);
        graph[i].erase(x);
    }
    cout << grana.first << " " << grana.second << endl;
    cout << resenje << endl;
}

int main()
{
    ios_base::sync_with_stdio();
    cin.tie(NULL);
    solve();
    return 0;
}

/*11
1 2
2 3
3 4
4 5
1 8
8 9
9 10
1 11
11 6
6 7
*/