#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <climits>
#include <cmath>
#include <iterator>

using namespace std;

#define sync ios::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define ll long long
#define vi vector<int>
#define all(a) (a).begin(), (a).end()

const int N = 205;
const int K = (1e4)+5;

vector<vi> dp;
int n,m,k;
vi a;
vector<vi> b;

int solve(int i, int s){
    if(i+1<n) return dp[i][0] += solve(i+1,s);
    for (int j =0;j<m;j++){
      if (s>b[i][j]){
        int r = b[i][j]+1;
        if (dp[i][r]) continue;
        dp[i][r] += ((j+1)*a[i]);
        if (i+1<n) dp[i][r] += solve(i+1,s-r);
      }
      else break;
    }
    return *max_element(all(dp[i]));
}

int main(){
    sync;
    cin >> n >> m >> k;
    a = vi(n);
    dp = vector<vi>(n,vi(k+1));
    for (int& i : a) cin >> i;
    b = vector<vi>(n,vi(m));
    for (int i = 0;i<n;i++){
        for (int j = 0;j<m;j++){
            cin >> b[i][j];
        }
        sort(all(b[i]));
    }
    cout << solve(0,k)+1 << '\n';
}