#include<iostream>
#include<queue>
#include<vector>
using namespace std;
#define eb emplace_back

const int N = 2e5+20;

int n;
bool visited[N];
int brgrana[N];
vector<vector<int>> e(N);

int bfs(int poc)
{
    fill(visited, visited+N, 0);
    queue<int> q;
    q.emplace(poc);
    while(!q.empty()) {
            int x = q.front();
            q.pop();
            visited[x] = 1;

            for (int p : e[x]) if(!visited[p]) {
                q.emplace(p);
            }

            if(q.size() == 0) return x;
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);

    cin >> n;
    for (int i = 1; i < n; i ++) {
        int u, v;
        cin >> u >> v;
        e[u].eb(v);
        e[v].eb(u);
        brgrana[u]++;
        brgrana[v]++;
    }
    int posl = bfs(1);
    int pretp = bfs(posl);

    int najgrana = 0;
    for (int i = 0; i < n; i++) if(brgrana[i]>brgrana[najgrana]) najgrana=i;
    cout << posl << ' ' << pretp << '\n' << najgrana;

    return 0;
}