#include <bits/stdc++.h>

using namespace std;

struct st{
    int l, d, x;
};

bool cmp(const st& st1, const st& st2){
    return st1.x < st2.x;
}

int main()
{

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;

    cin >> n >> m;

    int tmp = sqrt(n);

    vector<vector<int> > cap(tmp, vector<int>(tmp));
    if(n-tmp*tmp > 0) cap.push_back(vector<int>(n-tmp*tmp));

    vector<int> add(cap.size()), mine(cap.size(), INT_MAX);

    for(int i = 0; i < cap.size(); ++i){
        for(int j = 0; j < cap[i].size(); ++j){
            cin >> cap[i][j];
            if(cap[i][j] < mine[i]) mine[i] = cap[i][j];
        }
    }

    int ans = 0;

    vector<st> q(m);

    for(int i = 0; i < m; ++i){
        st tmpst;
        int l, r;

        cin >> l >> r;
        tmpst.l = l-1, tmpst.d = r-1, tmpst.x = r-l+1;
        q[i] = tmpst;

    }

    sort(q.begin(), q.end(), cmp);

    for(int i = 0; i < m; ++i){
        int l = q[i].l, r = q[i].d;

        int le = 0, de = le + cap[0].size();
        bool dosm = 1;

        for(int j = 0; j < cap.size() && dosm; ++j){
            de = le + cap[j].size();

            if((l <= le) && (de <= r+1)){
                if(mine[j] == 0) dosm = 0;
                le = de;
                continue;
            }

            int z = le, ind = 0;
            if(l > le) z = l, ind = l - le;

            for(; z <= min(r, de-1); ++z, ++ind){
                if(cap[j][ind]-add[j] == 0) dosm = 0;
            }

            le = de;
        }

        if(!dosm) { ++ans; continue; }

        le = 0, de = le + cap[0].size();

        for(int j = 0; j < cap.size(); ++j){
            de = le + cap[j].size();

            if((l <= le) && (de <= r+1)){
                le = de;
                ++add[j], --mine[j];
                continue;
            }

            int z = le, ind = 0;
            if(l > le) z = l, ind = l - le;

            for(; z <= min(r, de-1); ++z, ++ind){
                --cap[j][ind];

                if(cap[j][ind]-add[j] < mine[j]) mine[j] = cap[j][ind]-add[j];
            }

            le = de;
        }
    }


    cout << ans << '\n';
    return 0;
}