#include <bits/stdc++.h>

using namespace std;

#define endl "\n"

long long n,m,k;
char Polja[2000][2000];
long long mod = 1000000007;
long long brojresenja = 0;
bool visited[2000][2000];

long long dp[2000][2000];

int Proveradesno(long long indexi, long long indexj)
{
    int counter = 0;
    if(indexj==m)
    {
        counter=-1;
        return counter;
    }
    while(Polja[indexi][indexj]=='1')
    {
        counter++;
        indexj++;
        if(indexj==m)
        {
            counter=-1;
            return counter;
        }
    }

    return counter;
}

int Proveralevo(long long indexi, long long indexj)
{
    int counter = 0;
    if(indexj==-1)
    {
        counter=-1;
        return counter;
    }
    while(Polja[indexi][indexj]=='1')
    {
        counter++;
        indexj--;
        if(indexj==-1)
        {
            counter=-1;
            return counter;
        }
    }

    return counter;
}

void Bektrek(long long i, long long j)
{
    if(i==0)
    {
        brojresenja++;
        brojresenja = brojresenja%mod;
        return;
    }

    if(Polja[i-1][j]=='0' && !visited[i-1][j])
    {
        visited[i-1][j]=true;
        Bektrek(i-1,j);
        visited[i-1][j]=false;
    }

    int brojljudidesno = Proveradesno(i,j+1);

    if(brojljudidesno<=k && brojljudidesno!=-1 && !visited[i][j+1])
    {
        Polja[i][j+1]='0';
        Polja[i][j+brojljudidesno+1]='1';
        visited[i][j+1]=true;
        Bektrek(i,j+1);
        Polja[i][j+1]='1';
        Polja[i][j+brojljudidesno+1]='0';
        visited[i][j+1]=false;
    }

    int brojljudilevo = Proveralevo(i,j-1);

    if(brojljudilevo<=k && brojljudilevo!=-1 && !visited[i][j-1])
    {
        Polja[i][j-1]='0';
        Polja[i][j-brojljudilevo-1]='1';
        visited[i][j-1]=true;
        Bektrek(i,j-1);
        Polja[i][j-1]='1';
        Polja[i][j-brojljudilevo-1]='0';
        visited[i][j-1]=false;
    }
    return;
}


int main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    long long i,j;
    cin>>n>>m>>k;
    bool ind = true;

    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            cin>>Polja[i][j];
            if(Polja[i][j]=='1')ind=false;
        }
    }

    if(ind)
    {
        int res = 1;
        if(n==2)
        {
            res = m;
            cout<<res;
            return 0;
        }
        for(int i=0;i<n;i++)
        {
            res = (res*m)%mod;
        }
        cout<<res;
        return 0;
    }

    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            visited[i][j]=false;
        }
    }


    for(j=0;j<m;j++)
    {
        if(Polja[n-1][j]=='0')
        {
            visited[n-1][j]=true;
            Bektrek(n-1,j);
            visited[n-1][j]=false;
        }
    }
    cout<<brojresenja;
    return 0;
}