#include <iostream>
#include <vector>
#include <cmath>
#include <unordered_map>

long long s(long long n) {
    long long k = 0;
    while (n > 0) {
        k += n%10;
        n /= 10;
    }
    return k;
}

int main()
{
    //primitivno resenje
    std::unordered_map<int, int> k;
    int n, m;
    std::cin >> n >> m;
    std::vector<int> lim;
    for (int i = 0; i < n; i++) {
        int t;
        std::cin >> t;
        lim.push_back(t);
        k[t] = 0;
    }
    int res = 0;
    for (int i = 0; i < m; i++) {
        int l, r, j;
        std::cin >> l >> r;
        l--;
        r--;
        std::unordered_map<int, bool> ch;
        for (j = l; j <= r; j++) {
            if (k[j]+1 > lim[j]) {
                res++;
                break;
            }
            k[j]++;
            ch[j] = 1;
        }
        if (j < r + 1) {
            for (auto it = ch.begin(); it != ch.end(); it++) {
                k[it->first]--;
            }
        }
    }
    std::cout << res << std::endl;

    return 0;
}