#include<iostream>
#include<stdlib.h>

unsigned long long zbir_cifara(unsigned long long br)
{
    unsigned long long ret = 0;
    while(br != 0)
    {
        ret += br % 10;
        br /= 10;
    }
    return ret;
}

int main()
{
    unsigned long long X, Y, A, B;
    unsigned long long sn, trazeni;
    long odgovor = -1;

    std::cin >> X >> Y >> A >> B;

    unsigned long long brmin = X,
                brmax = Y;

    long long max_sn = (brmax - B) / A;
    long long min_sn = (brmin - B) / A;
    min_sn = (min_sn > 0)? min_sn : 1;

    if(B > brmax)
    {
        std::cout << odgovor;
        return 0;
    }

    for(unsigned long long i = min_sn; i <= max_sn; i++)
    {
        trazeni = i * A + B;
        if((zbir_cifara(trazeni) == i) && (trazeni >= brmin) && (trazeni <= brmax))
        {
            odgovor = trazeni;
            break;
        }
    }

    std::cout << odgovor;

    return 0;
}