#include<iostream>
#include<stdlib.h>

unsigned long long zbir_cifara(unsigned long long br)
{
    unsigned long long ret = 0;
    while(br > 0)
    {
        ret += br % 10;
        br /= 10;
    }
    return ret;
}

int main()
{
    unsigned long long A, B;
    unsigned long long sn, trazeni;
    long odgovor = -1;

    long long brmin, brmax, max_sn, min_sn;

    std::cin >> brmin >> brmax >> A >> B;


    if(B > brmax)
    {
        std::cout << odgovor;
        return 0;
    }

    if(A == 0)
    {
        if((B >= brmin) && (B <= brmax))
            odgovor = B;
        std::cout << odgovor;
        return 0;

    }
    else
    {
        max_sn = (brmax - B) / A;
        if(brmin >= B)
            min_sn = (brmin - B) / A;
        else
            min_sn = 1;
    }


    for(unsigned long long i = min_sn; i <= max_sn; i++)
    {
        trazeni = i * A + B;
        if((zbir_cifara(trazeni) == i) && (trazeni >= brmin))
        {
            odgovor = trazeni;
            break;
        }
    }

    std::cout << odgovor;

    return 0;
}