#include <bits/stdc++.h>
#include <iostream>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> order_set;
mt19937 mt_rand(chrono::high_resolution_clock::now().time_since_epoch().count());
//uniform_int_distribution<int> gen(-1e9, 1e8); ///(min, max)
//int random() {return gen(mt_rand);}
const int mxN = 2e5+5;
const int mod = 1e9+7;
const int mxlogN = 19;
const int mxK = 26;
const int inf = 1e9;
const int K = 40000;

vector<int> adj[mxN];
int up[mxlogN][mxN], down[mxN];
vector<int> who[mxN];
void dfs(int i, int p=0, int d=0)
{
    up[0][i]=p, down[i]=d;
    who[down[i]].push_back(i);
    for(int j : adj[i]) if(j!=p) dfs(j, i, d+1);
}
int goup(int i, int k)
{
    if(!k) return i;
    for(int j = mxlogN-1; j>=0; j--)
    {
        if(k>(1<<j))
        {
            k-=1<<j;
            i = up[j][i];
        }
    }
    return up[0][i];
}
int lca(int i, int j)
{
    if(down[i] < down[j]) swap(i,j);
    i = goup(i, down[i]-down[j]);
    if(i==j) return i;
    for(int k = mxlogN-1; k>=0; k--)
    {
        if(up[k][i]!=up[k][j])
        {
            i = up[k][i], j = up[k][j];
        }
    }
    return up[0][i];
}
int dist(int i, int j)
{
    return down[i]+down[j]-2*down[lca(i,j)];
}
int ans[mxN];
int center(int i, int j, int dd)
{
    if(down[i]<down[j]) swap(i, j); ///i je nizi
    return goup(i, dd/2);
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;
    set<pair<int, int>> postoji;
    for(int i = 1; i < n; i++)
    {
        int u, v; cin >> u >> v;
        adj[u].push_back(v);
        adj[v].push_back(u);
        if(u>v) swap(u,v);
        postoji.insert({u,v});
    }
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 1);
    random_shuffle(ord.begin(), ord.end());
    ll ans=inf;
    int root, A, B;
    bool any=0;
    for(int iter=0; iter < min(n,2000); iter++)
    {
        //cout << "iter " << iter << "\n";
        int i = ord[iter];
        for(int dep=0; dep < n; dep++) who[dep].clear();
        dfs(i);
        //cout << "dodje\n";
        for(int j = 1; j < mxlogN; j++)
        {
            for(int i = 1; i <= n; i++)
            {
                up[j][i]=up[j-1][up[j-1][i]];
            }
        }
        //cout << "ovde\n";
        int d=-inf;
        int l=-1, r=-1;
        for(int dep = n-1; dep>=0; dep--)
        {
            for(int j : who[dep])
            {
                //if(i==1)
                //{
                    //cout << "ima na " << dep << " " << j << "\n";
                //}
                if(d==-inf)
                {
                    d=0;
                    l=r=j;
                }
                else
                {
                    int d2 = dist(l, j);
                    int d3 = dist(r, j);
                    if(d3>=d2 && d3>d)
                    {
                        d=d3;
                        l=j;
                    }
                    if(d2>=d3 && d2>d)
                    {
                        d=d2;
                        r=j;
                    }
                }
                //if((d+1)/2+1>=dep-1) break;
            }
            //cout << "nea\n";
            //(d+1)/2+1 mogu da imam i moram da imam dep-1
            ll cur = max((d+1)/2+1, dep-1);
            //if(i==1&&dep==2)
            //{
                //cout << "baka " << cur << "\n";
                //cout << "d " << d << "\n";
                //for(int j :)
            //}
            if(cur<ans)
            {
                ans=cur;
                root=i;
                if(d==-inf)
                {
                    any=1;
                    continue;
                }
                A=root;
                //cout << "burag\n";
                B=center(l, r, d);
                //cout << "baka\n";
                any = B==A||up[0][B]==A;
                ///nadji centar od ova dva
            }
        }
    }
    //cout << "CUR " << ans << "\n";
    if(any)
    {
        for(int i = 1; i <= n; i++)
        {
            for(int j = i+1; j <= n; j++)
            {
                if(!postoji.count({i,j}))
                {
                    A=i, B=j;
                    i=n, j=n;
                    continue;
                }
            }
        }
    }
    //cout << "any " << any << "\n";
    cout << A << " " << B << "\n" << root << "\n";
}