#include <bits/stdc++.h>
#define forn(i, n) for (int i = 0; i < n; i++)
typedef long long ll;
using namespace std;
const int oo = 2e5+7;
int n;
vector<int> con[oo];
ll c2(ll f) {
    return f * (f + 1) / 2;
}
ll opt(ll f) {
    ll a = f / 2, b = (f + 1) / 2;
    return c2(a) + c2(b);
}
int next(int node, int last) {
    for (int e: con[node]) if (e != last) return e;
    return -1;
}
bool moze(int node, int last) {
    return next(node, last) != -1;
}
void cepaj(int& node, int& last) {
    int node1 = next(node, last);
    int last1 = node;
    node = node1;
    last = last1;
}
int getsplit(int node, int last, int c) {
    if (c == 0) return node;
    for (int e: con[node]) {
        if (e != last) {
            return getsplit(e, node, c-1);
        }
    }
    throw 2;
}
void lanac() {
    int node = 0;
    while (con[node].size() != 1) node++;
    int levo = 0, last = -1;
    ll bestc = LONG_MAX;
    int bestnode = -1, bestlast = -1, bestdesno = -1;
    for (; moze(node, last); cepaj(node, last), levo++) {
        int desno = n - (levo + 1);
        ll cost = opt(desno) + c2(levo);
        if (cost < bestc) {
            bestc = cost;
            bestnode = node;
            bestlast = last;
            bestdesno = desno;
        }
    }
    int l1 = getsplit(bestnode, bestlast, bestdesno / 2);
    cout << bestnode + 1 << " " << l1 + 1 << endl;
    cout << bestnode + 1 << endl;
}
int level[oo];
int cnt[oo];
ll p[oo];
void dfsl(int node, int last, int lvl) {
    level[node] = lvl;
    for (int e: con[node]) if (e != last) dfsl(e, node, lvl + 1);
}
int dfsc(int node, int last) {
    if (cnt[node] != -1) return cnt[node];
    cnt[node] = 1;
    for (int e: con[node]) if (e != last) cnt[node] += dfsc(e, node);
    return cnt[node];
}
ll dfsp(int node, int last) {
    if (p[node] != -1) return p[node];
    p[node] = 0;
    for (int e: con[node]) if (e != last) p[node] += dfsp(e, node) + dfsc(e, node);
    return p[node];
}
ll profit(int det) {
    return (level[det] - 1) * cnt[det];
}
pair<ll, int> solve(int r) {
    dfsl(r, -1, 0);
    forn(i, n) cnt[i] = p[i] = -1;
    dfsc(r, -1);
    dfsp(r, -1);
    int det = 0;
    forn(i, n) if (profit(i) > profit(det)) det = i;
    return {p[r] - profit(det), det};
}
bool islanac() {
    forn(i, n) if (con[i].size() > 2) return false;
    return true;
}
pair<int, int> random() {
    forn(i, n) if (con[i].size() != n - 1) {
        bool pp[n] = {0};
        pp[i] = 1;
        for (int e: con[i]) pp[e] = 1;
        forn(j, n) if (!pp[j]) return {i, j};
        throw 3;
    }
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    forn(i, n-1) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        con[a].push_back(b);
        con[b].push_back(a);
    }
    if (false && islanac()) lanac();
    else {
        ll res = LONG_MAX;
        int dom = -1, sub = -1;
        forn(i, n) {
            auto out = solve(i);
            ll kurac = out.first;
            int palac = out.second;
            if (kurac < res) {
                res = kurac;
                dom = i;
                sub = palac;
            }
        }
        int best = dom;
        if (find(con[dom].begin(), con[dom].end(), sub) != con[dom].end()) {
                auto pp = random();
                dom = pp.first;
                sub = pp.second;
        }
        cout << dom + 1 << " " << sub + 1 << endl;
        cout << best + 1 << endl;
    }
}