#include <bits/stdc++.h>
#define forn(i, n) for (int i = 0; i < n; i++)
typedef long long ll;
using namespace std;
const int oo = 2e5+7;
int n;
vector<int> con[oo];
int level[oo], parent[oo];
void dfsl(int node, int last, int lvl) {
    parent[node] = last;
    level[node] = lvl;
    for (int e: con[node]) if (e != last) dfsl(e, node, lvl + 1);
}
pair<int, int> random() {
    forn(i, n) if (con[i].size() != n - 1) {
        bool pp[n] = {0};
        pp[i] = 1;
        for (int e: con[i]) pp[e] = 1;
        forn(j, n) if (!pp[j]) return {i, j};
        throw 3;
    }
}
int maxl() {
    int m = -1;
    forn(i, n) m = max(m, level[i]);
    return m;
}
int getn(int lvl) {
    forn(i, n) if (level[i] == lvl) return i;
    throw 1;
}
int in[oo], out[oo], cnter;
void euklid(int node, int last) {
    in[node] = cnter++;
    for (int e: con[node]) if (e != last) euklid(e, node);
    out[node] = cnter++;
}
bool familija(int cale, int sin) {
    return in[cale] < in[sin] && in[sin] < out[cale];
}
pair<int, int> solve(int r) {
    cnter = 0;
    dfsl(r, -1, 0);
    euklid(r, -1);
    int cntl[n] = {0};
    forn(i, n) cntl[level[i]]++;
    int ml = maxl();
    vector<int> sus;
    forn(i, n) if (level[i] == ml) sus.push_back(i);
    sort(sus.begin(), sus.end(), [](int i, int j) {return in[i] < in[j];});
    int l = 0, cale = sus[0];
    int m = sus.size();
    while (l < m) {
        while (l < m && familija(cale, sus[l])) l++;
        if (l == m) break;
        cale = parent[cale];
    }
    int otherlvl = -1;
    forn(i, n) if (!familija(cale, i)) otherlvl = max(otherlvl, level[i]);
    int clvl = level[cale];
    return {max(otherlvl, ml - min(0, clvl - 1)), cale};
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    forn(i, n-1) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        con[a].push_back(b);
        con[b].push_back(a);
    }
    int bcost = INT_MAX;
    int dom, sub;
    forn(i, n) {
        auto pp = solve(i);
        int dom1 = i, sub1 = pp.second, cost = pp.first;
        if (bcost > cost) {
            bcost = cost;
            dom = dom1;
            sub = sub1;
        }
    }
    int best = dom;
    if (dom == sub || find(con[dom].begin(), con[dom].end(), sub) != con[dom].end()) {
        auto pp = random();
        dom = pp.first;
        sub = pp.second;
    }
    cout << dom + 1 << " " << sub + 1 << endl;
    cout << best + 1 << endl;
}