#include<bits/stdc++.h>
#define MAXEL 1000000007

using namespace std;

bool cmp(pair<int,int> p1, pair<int,int> p2){
    if(p1.first>p2.first && p1.second>p2.second){
        return 0;
    }
    if(p1.first>=p2.first && p1.second<=p2.second){
        return 1;
    }
    if(p1.first<=p2.first && p1.second>=p2.second){
        return 0;
    }
    if(p1.first<p2.first && p1.second<p2.second){
        return 1;
    }
}

int n;
int seg[525000];
int lazy[525000];
pair<int,int> borders[525000];
int pow2(int k){
    if(k==1){
        return 1;
    }
    return 2*pow2((k+1)/2);
}
int notenough(int l,int r,int x,int k){
    if(l>borders[x].second){
        return false;
    }
    if(r<borders[x].first){
        return false;
    }
    if(l==borders[x].first && r==borders[x].second){
        if(seg[x]>k){
            return false;
        }
        return true;
    }
    if(notenough(l,min(r,borders[2*x].second),2*x,k+lazy[x]) || notenough(max(l,borders[2*x+1].first),r,2*x+1,k+lazy[x])){
        return true;
    }
    return false;
}
void decrease(){

}

int main(){
    int m;
    cin>>n>>m;
    int p=pow2(n);
    int a[200010];
    pair<int,int> edges[200010];
    for(int i=0;i<n;i++){
        cin>>a[i];
        seg[p+i]=a[i];
    }
    for(int i=p+n;i<2*p;i++){
        seg[i]=MAXEL;
    }
    for(int i=p-1;i>0;i--){
        seg[i]=min(seg[2*i],seg[2*i+1]);
    }
    for(int i=1;i<2*p;i++){
        lazy[i]=0;
    }
    for(int i=p;i<2*p;i++){
        borders[i].first=i-p+1;
        borders[i].second=i-p+1;
    }
    for(int i=p-1;i>0;i--){
        borders[i].first=borders[2*i].first;
        borders[i].second=borders[2*i+1].second;
    }
    for(int i=0;i<m;i++){
        cin>>edges[i].first>>edges[i].second;
    }
    sort(edges,edges+m,cmp);
    int cnt=0;
    for(int i=0;i<m;i++){
        if(notenough(edges[i].first,edges[i].second,1,0)){
            cnt++;
        }
        else{
            decrease();
        }
    }
    cout<<cnt;
    return 0;
}